#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// Last Modified 12July2017 to reset where bio tags plot on the graphs

	Function BioPMag_Plot( )
		SetDataFolder root:	
			String/G G_Hole, G_FontSize, G_XAxisName	
			String Hole = G_Hole, FontSize = G_FontSize, XAxisName = G_XAxisName			
			Prompt Hole "Hole ( e.g. U1338A - Use U1338S for all holes on 1 line ):"			
			DoPrompt "BioPMag_Plot", Hole	//Allows the Hole to be user defined.
			G_Hole = Hole; AbortOnValue (V_Flag), 1	
			Variable/G G_TopPC, G_BottomPC
			Variable TopPC = G_TopPC, BottomPC = G_BottomPC, LabelAngle
			String/G G_Folder, G_Species, G_CCSF, G_Uncert, G_DatumHole, G_TopBottom		
			String Folder = G_Folder, Species = G_Species, TopBottom = G_TopBottom
			String Uncert = G_Uncert, DatumHole = G_DatumHole
			String DatumCCSF// = G_CCSF
			Prompt Folder "Datum Folder", popup, FolderList(RemoveEnding(Hole))	//The popup should only display folders that start with the user-defined Site
			DoPrompt "BioPMag_Plot", Folder; 
			G_Folder = Folder; AbortOnValue (V_Flag), 1		
			Make/O/N = 3 Num
			Num = { 0 ,45 ,90 }
		SetDataFolder $"root:" + Folder
			Check4DoubleUnderscoresInNames( )
			Prompt DatumHole "Datum Wave With Hole ID", popup, SortList( WaveList( Hole + "*", ";", "" ) )
			Prompt Species "Species or Reversal List", popup, SortList( WaveList( Hole + "*", ";", "" ) )
			Prompt DatumCCSF "Choose Depths (CCSF)", popup, SortList( WaveList( Hole + "*", ";", "" ) )
			Prompt Uncert "Choose Uncertainty", popup, SortList( WaveList( Hole + "*", ";", "" ) + "None" ) 
			Prompt XAxisName "X Axis Name", popup, "Depth;Age;OtherX" 
			DoPrompt "BioPMag_Plot", DatumHole, Species, DatumCCSF, Uncert, XAxisName; G_Uncert = Uncert; 	
			G_Species = Species; G_CCSF = DatumCCSF; G_XAxisName = XAxisName;G_DatumHole = DatumHole; G_Species = Species 
			AbortOnValue (V_Flag), 1			
			Variable V1 = 2
			Prompt TopPC "Top %"
			Prompt BottomPC "Bottom %"
			Prompt TopBottom "Top or Bottom Axis:", popup, "T;B"
			Prompt V1, "Label Angle", popup, "0;45;90"
			Prompt FontSize, "Font Size for Tags"
			DoPrompt "BioPMag_Plot" BottomPC, TopPC, TopBottom, V1, FontSize;
			G_FontSize = FontSize
			G_TopPC = TopPC; G_BottomPC = BottomPC; G_TopBottom = TopBottom
			LabelAngle = Num[ V1 - 1 ]
			KillWaves Num
			AbortOnValue (V_Flag), 1	
			Print "BioPMag_Plot_F( \"" + Hole + "\", \"" + Folder + "\", \"" + DatumHole + "\", \"" + Species + "\",\"" + DatumCCSF + "\",\"" + Uncert + "\", \"" + XAxisName + "\", " + Num2Str( BottomPc ) + "," + Num2Str( TopPC) + ",\"" + TopBottom + "\",", LabelAngle, ", \"" + FontSize + "\" )"
			BioPMag_Plot_F( Hole, Folder, DatumHole, Species, DatumCCSF, Uncert, XAxisName, BottomPc, TopPC, TopBottom, LabelAngle, FontSize )		
	End 

------------------------------------------------------------------------------------------------------------------------
	
	Function BioPMag_Plot_F( Hole, Folder, DatumHole, Species, DatumCCSF, Uncert, XAxisName, BottomPC, TopPc, TopBottom, LabelAngle, FontSize )
		String Folder, Species, DatumCCSF, Uncert, DatumHole, TopBottom, FontSize, Hole, XAxisName
		Variable TopPC, BottomPC, LabelAngle	
		SetDataFolder root:
			String/G G_XAxisName
			String HoleLetter = Hole[ Strlen( Hole ) - 1 ]
			If( StringMatch( XAxisName, "OtherX") ) // This prompt is the case where the X axis will be something other than depth or age
				Prompt XAxisName, "Enter a name for the X axis:"
				DoPrompt "NewDataPlot_F", XAxisName
				G_XAxisName = XAxisName; AbortOnValue V_Flag, 0
			EndIf
			XAxisName = XAxisName + "Axis"
		NewDataFolder/O/S Xtras
		NewDataFolder/O/S BioPmag
			DFREF XtrasFldr = GetDataFolderDFR( )
			String Ones = Hole + "_" + DataWaveTechnique( DatumCCSF ) + "_Ones"
 			Make/O/N = 0 $Ones
			WAVE One = $Ones
		SetDataFolder $"root:" + Folder
			String Bug = Hole + "_" + DataWaveTechnique( DatumCCSF ) // This string is the name of the Y axis for these data
			WAVE/Z Mid = $DatumCCSF, U = $Uncert	
			WAVE/T Names = $Species, HoleWave = $DatumHole		
			Duplicate/O Mid One	// Makes these 2 plotting waves the same length as the data 
			One = 1
		SetDataFolder root:Xtras:BioPmag
			Duplicate/O Mid $Hole + DataWaveTechnique( DatumCCSF ) + "Depth"
			WAVE HoleDepths = $Hole + DataWaveTechnique( DatumCCSF ) + "Depth"
		SetDataFolder root:
			If( !StringMatch( HoleLetter, "S" ) )	
				HoleDepths = StringMatch( HoleLetter, HoleWave ) ? HoleDepths : NaN
			EndIf
			If( StrLen( WinList( "*", ";", "WIN:1" ) ) == 0 ) // In case there are no open graphs and you just want to look at the bio/pmag events
				Display
			Endif
			RemoveFromGraph/Z $Ones
			If( StringMatch( TopBottom, "T" ) )	// Plot on top or bottom X axis
				AppendToGraph/T=$XAxisName/L=$Bug One vs HoleDepths
			Else
				AppendToGraph/B=$XAxisName/L=$Bug One vs HoleDepths
			EndIf
			ModifyGraph tick($Bug)=3,noLabel($Bug)=2,freePos($Bug)=0
			ModifyGraph mode($Ones)=3,msize=6;DelayUpdate
			ModifyGraph rgb($Ones)=(0,65535,60000)
			ModifyGraph mrkThick($Ones)=2
			If( !Stringmatch( Uncert, "None" ) )
				ErrorBars/T=2 $Ones X, wave=( U, U )
			EndIf
			ModifyGraph axisEnab($Bug)= { ( BottomPC / 100 ), ( TopPC/100 ) }
			Variable i = 0
			For( i = 0; i < NumPnts( One ) ; i += 1 )
				If( StringMatch( HoleWave[ i ], HoleLetter ) || StringMatch( HoleLetter, "S" ) )
					String Sp = "\\Z" +FontSize + "\\K(65535,0,0)" + HoleWave[ i ] + " \\K(0,0,0)" + Names[ i ], Tagname = Bug + Num2Str( i )
					Switch( LabelAngle )
						Case 0:
							Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle )  $Ones,  i, Sp
							Break;
						Case 45:
							Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle ) /A=LB  $Ones,  i, Sp
							Break;
						Case 90:
							Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle ) /A=MB $Ones,  i, Sp
							Break;
					EndSwitch
				EndIf
			EndFor
		SetDataFolder root:

	End
	
	********************************************************************
	
	Function Stretched_BioPMag_Plot()									// Now updated to include BaseSite behind CCSF and Uncert
		SetDataFolder root:
			String/G G_StretchSite, G_BaseSite, G_Folder, G_BTies, G_STies, G_FontSize										//introduces global variables
			String/G G_Hole, G_Species, G_CCSF, G_Uncert
			Variable/G G_TopPC, G_BottomPC
			String StretchSite, BaseSite, FontSize = G_FontSize																							//introduces string for Stretch site name
			StretchSite = G_StretchSite		
			BaseSite = G_BaseSite																						
			Prompt StretchSite "Stretch Site:"			
			Prompt BaseSite "Base Site:"			
			DoPrompt "Stretched_BioPMag_Plot", StretchSite, BaseSite; AbortOnValue V_Flag, 0			//Allows StretchSite to be altered, but it will originally show G_S2
			G_StretchSite	 = StretchSite									
			G_BaseSite	 = BaseSite			
		
			String BTies = G_BTies, STies = G_STies
			String Folder = G_Folder, Species = G_Species, DatumCCSF = G_CCSF, Uncert = G_Uncert, DatumHole = G_Hole
			Variable TopPC = G_TopPC, BottomPC = G_BottomPC

		SetDataFolder $BaseSite + "_" + StretchSite + "_Results"
			DFREF ResultsFldr = GetDataFolderDFR( )
			Prompt BTies, "Base2Stretch Tie Wave", popup, WaveList( "*Ties", ";", "" )
			Prompt STies, "Stretch2Base Tie Wave", popup, WaveList( "*Ties", ";", "" )
			DoPrompt "Stretched_BioPMag_Plot", BTies, STies; AbortOnValue V_Flag, 0
			G_BTies = BTies; G_STies = STies
			WAVE BaseTies = $BTies, StretchTies = $STies
		SetDataFolder root:
			Prompt Folder "Datum Folder", popup, FolderList(StretchSite)					//These popups should only display folders that start with the Strecth Site name
			DoPrompt "Stretched_BioPMag_Plot", Folder; AbortOnValue V_Flag, 0
			G_Folder = Folder; 
		SetDataFolder $"root:" + Folder
			Prompt DatumHole "Wave With Hole ID", popup, WaveList( "*", ";", "" )		
			Prompt Species "Species or Reversal List", popup, WaveList( "*", ";", "" )
			Prompt DatumCCSF "Choose Depths (CCSF)", popup, WaveList( "*", ";", "" )
			Prompt Uncert "Choose Uncertainty", popup, WaveList( "*", ";", "" ) + "None" 
			DoPrompt "Stretched_BioPMag_Plot", DatumHole, Species, DatumCCSF, Uncert; AbortOnValue V_Flag, 0
			G_Hole = DatumHole; G_Species = Species; G_CCSF = DatumCCSF; G_Uncert = Uncert
			Variable LabelAngle 
			Make/O/N = 3 Num
			Num = { 0 ,45 ,90 }
			Variable V1 = 2
			Prompt TopPC "Top %"
			Prompt BottomPC "Bottom %"
			Prompt V1, "Label Angle", popup, "0;45;90"
			Prompt FontSize, "Font Size"
			DoPrompt "Limits of Plot on Graph (%)" BottomPC, TopPC, V1, FontSize; AbortOnValue V_Flag, 0
			G_TopPC = TopPC; G_BottomPC = BottomPC
			LabelAngle = Num[ V1 - 1 ]
			KillWaves Num	
			Stretched_BioPMag_Plot_F( BaseSite, StretchSite, Folder, BTies, STies, DatumHole, Species, DatumCCSF, Uncert, BottomPC, TopPC, LabelAngle, FontSize )	
			Print "Stretched_BioPMag_Plot_F( \"" + BaseSite + "\", \"" + StretchSite+ "\", \"" +Folder + "\", \"" + BTies + "\", \"" + STies + "\", \"" + DatumHole + "\", \"" + Species + "\", \"" + DatumCCSF + "\", \"" + Uncert + "\"," + Num2Str( BottomPc ) + "," + Num2Str( TopPC), ",",  LabelAngle, ",\"" + FontSize + "\" )\r\r"
	End		

	********************************************************************
	
	Function Stretched_BioPMag_Plot_F( BaseSite, StretchSite, Folder, BTies, STies, DatumHole, Species, DatumCCSF, Uncert, BottomPC, TopPC, LabelAngle, FontSize )					// Now updated to include BaseSite behind CCSF and Uncert
		String BaseSite, StretchSite, Folder, BTies, STies, DatumHole, Species, DatumCCSF, Uncert, FontSize
		Variable TopPC, BottomPC, LabelAngle

		PauseUpdate;
		SetDataFolder root:
		SetDataFolder $"root:" + Folder
		String/G G_FontSize = FontSize
			WAVE DatumDepth = $DatumCCSF,  WUncert = $Uncert
			WAVE/T Names = $Species, HoleWave = $DatumHole		
		SetDataFolder $"root:" + BaseSite + "_" + StretchSite + "_Results"
			DFREF ResultsFldr = GetDataFolderDFR( )
			WAVE BTie = $BTies, STie = $STies
			Duplicate/O DatumDepth $DatumCCSF + BaseSite, $Uncert + BaseSite, UncertTemp1, UncertTemp2
			WAVE WStr = $DatumCCSF + BaseSite, WUncStr = $Uncert + BaseSite
			WStr = interp( DatumDepth, STie, BTie )
			If( !Stringmatch( Uncert, "None" ) )
				Duplicate/O WUncert $Uncert + BaseSite
				UncertTemp1=DatumDepth + WUncert
				UncertTemp2 = interp( UncertTemp1, STie, BTie )
				WUncStr = UncertTemp2 - WStr
			EndIf
			KillWaves/Z UncertTemp1, UncertTemp2
			String Bug = DataWaveHole( DatumCCSF ) + "_" + DataWaveTechnique( DatumCCSF ) + BaseSite
		SetDataFolder $"root:Xtras"
			DFREF XtrasFldr = GetDataFolderDFR( )
			WAVE Ones = $DataWaveHole( DatumCCSF ) + "_" + DataWaveTechnique( DatumCCSF ) + "_Ones"
			String OnesString = DataWaveHole( DatumCCSF ) + "_" + DataWaveTechnique( DatumCCSF ) + "_OnesStr"
			Duplicate/O Ones $DataWaveHole( DatumCCSF ) + "_" + DataWaveTechnique( DatumCCSF ) + "_OnesStr"
			String ColorString = DataWaveHole( DatumCCSF ) + "_" + DataWaveTechnique( DatumCCSF ) + "_Colors"
			WAVE OnesStr =  $DataWaveHole( DatumCCSF ) + "_" + DataWaveTechnique( DatumCCSF ) + "_OnesStr"
			WAVE Colors = $DataWaveHole( DatumCCSF ) + "_" + DataWaveTechnique( DatumCCSF ) + "_Colors"
			RemoveFromGraph/Z $DataWaveHole( DatumCCSF ) + "_" + DataWaveTechnique( DatumCCSF ) + "_OnesStr"
			AppendToGraph/T/L=$Bug OnesStr vs WStr
			ModifyGraph tick($Bug)=3,noLabel($Bug)=2,freePos($Bug)=0
//			ModifyGraph msize=6
			ModifyGraph mode( $OnesString )=3,msize( $OnesString )=12, mrkThick($OnesString)=2
			ModifyGraph rgb($OnesString)=(0,65535,60000)
			If( !Stringmatch( Uncert, "None" ) )
				ErrorBars/T=2 $OnesString X, wave = ( WUncStr, WUncStr )
			Else
				KillWaves/Z WUncStr
			EndIf
//			SetAxis $Bug 0.5,1.5
			ModifyGraph axisEnab($Bug)= { ( BottomPC / 100 ), ( TopPC/100 ) }
			Variable i = 0
			For( i = 0; i < NumPnts( Ones ) ; i += 1 )
				String Sp = "\\Z" + FontSize + "\\K(65535,0,0)" + HoleWave[ i ] + " \\K(0,0,0)" + Names[ i ], Tagname = Bug + Num2Str( i )
				Switch( LabelAngle )
					Case 0:
						Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle )  $OnesString,  i, Sp
						Break;
					Case 45:
						Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle ) /A=LB  $OnesString,  i, Sp
						Break;
					Case 90:
						Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle ) /A=MB $OnesString,  i, Sp
						Break;
				EndSwitch
			EndFor
		SetDataFolder root:	
			WaveStats/Q BTie
			WStr = WStr > V_Max ? NaN : WStr 
	End
		
------------------------------------------------------------------------------------------------------------------------

//	Function BioPMag_Plot( )
		SetDataFolder root:	
			String/G G_Hole	, G_FontSize, G_XAxisName	
			String Hole = G_Hole, FontSize = G_FontSize, XAxisName = G_XAxisName			
			Prompt Hole "Hole ( e.g. U1338A - Use U1338S for all holes on 1 line ):"			
			DoPrompt "BioPMag_Plot", Hole	//Allows the Hole to be user defined.
			G_Hole = Hole; AbortOnValue (V_Flag), 1	
			Variable/G G_TopPC, G_BottomPC
			Variable TopPC = G_TopPC, BottomPC = G_BottomPC, LabelAngle
			String/G G_Folder, G_Species, G_CCSF, G_Uncert, G_DatumHole, G_TopBottom		
			String Folder = G_Folder, Species = G_Species, TopBottom = G_TopBottom
			String Uncert = G_Uncert, DatumHole = G_DatumHole
			String DatumCCSF// = G_CCSF
			Prompt Folder "Datum Folder", popup, FolderList(RemoveEnding(Hole))					//The popup should only display folders that start with the user-defined Site
			DoPrompt "BioPMag_Plot", Folder; AbortOnValue (V_Flag), 1		
			Make/O/N = 3 Num
			Num = { 0 ,45 ,90 }
		SetDataFolder $"root:" + Folder
			Check4DoubleUnderscoresInNames( )
			Prompt DatumHole "Datum Wave With Hole ID", popup, SortList( WaveList( "*", ";", "" ) )
			Prompt Species "Species or Reversal List", popup, SortList( WaveList( "*", ";", "" ) )
			Prompt DatumCCSF "Choose Depths (CCSF)", popup, SortList( WaveList( "*", ";", "" ) )
			Prompt Uncert "Choose Uncertainty", popup, SortList( WaveList( "*", ";", "" ) + "None" ) 
			DoPrompt "BioPMag_Plot", DatumHole, Species, DatumCCSF, Uncert; AbortOnValue (V_Flag), 1			
			Variable V1 = 2
			Prompt TopPC "Top %"
			Prompt BottomPC "Bottom %"
			Prompt TopBottom "Top or Bottom Axis:", popup, "T;B"
			Prompt V1, "Label Angle", popup, "0;45;90"
			Prompt FontSize, "Font Size for Tags"
			DoPrompt "BioPMag_Plot" BottomPC, TopPC, TopBottom, V1, FontSize;
			G_Folder = Folder; G_Species = Species; G_CCSF = DatumCCSF; G_FontSize = FontSize
			G_Uncert = Uncert; G_DatumHole = DatumHole; G_TopPC = TopPC; G_BottomPC = BottomPC; G_TopBottom = TopBottom
			LabelAngle = Num[ V1 - 1 ]
			KillWaves Num
			AbortOnValue (V_Flag), 1	
			Print "BioPMag_Plot_F( \"" + Hole + "\", \"" + Folder + "\", \"" + DatumHole + "\", \"" + Species + "\",\"" + DatumCCSF + "\",\"" + Uncert + "\"," + Num2Str( BottomPc ) + "," + Num2Str( TopPC) + ",\"" + TopBottom + "\",", LabelAngle, ", \"" + FontSize + "\" )"
			BioPMag_Plot_F( Hole, Folder, DatumHole, Species, DatumCCSF, Uncert, BottomPc, TopPC, TopBottom, LabelAngle, FontSize )		
	End 

------------------------------------------------------------------------------------------------------------------------
	
//	Function BioPMag_Plot_F( Hole, Folder, DatumHole, Species, DatumCCSF, Uncert, BottomPC, TopPc, TopBottom, LabelAngle, FontSize )
		String Folder, Species, DatumCCSF, Uncert, DatumHole, TopBottom, FontSize, Hole
		Variable TopPC, BottomPC, LabelAngle
		PauseUpdate;		
		SetDataFolder root:
			String HoleLetter = Hole[ Strlen( Hole ) - 1 ]
		NewDataFolder/O/S Xtras
		NewDataFolder/O/S BioPmag
			DFREF XtrasFldr = GetDataFolderDFR( )
			String Ones = Hole + "_" + DataWaveTechnique( DatumCCSF ) + "_Ones"
 			Make/O/N = 0 $Ones
			WAVE One = $Ones
		SetDataFolder $"root:" + Folder
			String Bug = Hole + "_" + DataWaveTechnique( DatumCCSF ) // This string is the name of the Y axis for these data
			WAVE/Z Mid = $DatumCCSF, U = $Uncert	
			WAVE/T Names = $Species, HoleWave = $DatumHole		
			Duplicate/O Mid One	// Makes these 2 plotting waves the same length as the data 
			One = 1
		SetDataFolder root:Xtras:BioPmag
			Duplicate/O Mid $Hole + DataWaveTechnique( DatumCCSF ) + "Depth"
			WAVE HoleDepths = $Hole + DataWaveTechnique( DatumCCSF ) + "Depth"
		SetDataFolder root:
			If( !StringMatch( HoleLetter, "S" ) )	
				HoleDepths = StringMatch( HoleLetter, HoleWave ) ? HoleDepths : NaN
			EndIf
			If( StrLen( WinList( "*", ";", "WIN:1" ) ) == 0 ) // In case there are no open graphs and you just want to look at the bio/pmag events
				Display
			Endif
			RemoveFromGraph/Z $Ones
			If( StringMatch( TopBottom, "T" ) )	// Plot on top or bottom X axis
				AppendToGraph/T/L=$Bug One vs HoleDepths
			Else
				AppendToGraph/B/L=$Bug One vs HoleDepths
			EndIf
			ModifyGraph tick($Bug)=3,noLabel($Bug)=2,freePos($Bug)=0
			ModifyGraph mode($Ones)=3,msize=6;DelayUpdate
			ModifyGraph rgb($Ones)=(0,65535,60000)
			ModifyGraph mrkThick($Ones)=2
			If( !Stringmatch( Uncert, "None" ) )
				ErrorBars/T=2 $Ones X, wave=( U, U )
			EndIf
			ModifyGraph axisEnab($Bug)= { ( BottomPC / 100 ), ( TopPC/100 ) }
			Variable i = 0
			For( i = 0; i < NumPnts( One ) ; i += 1 )
				If( StringMatch( HoleWave[ i ], HoleLetter ) || StringMatch( HoleLetter, "S" ) )
					String Sp = "\\Z" +FontSize + "\\K(65535,0,0)" + HoleWave[ i ] + " \\K(0,0,0)" + Names[ i ], Tagname = Bug + Num2Str( i )
					Switch( LabelAngle )
						Case 0:
							Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle )  $Ones,  i, Sp
							Break;
						Case 45:
							Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle ) /A=LB  $Ones,  i, Sp
							Break;
						Case 90:
							Tag/C/TL={fat=0.2} /N = $TagName /X = 0 /Y = 0 /I =1 /L = 2 /F = 2 /O = ( LabelAngle ) /A=MB $Ones,  i, Sp
							Break;
					EndSwitch
				EndIf
			EndFor
		SetDataFolder root:

	End
	
	********************************************************************
