﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.
	
	Function CODD_TuningSetUp()
		SetDataFolder root:
			String/G G_Target, G_TargetAge, G_Data, G_DataAge, G_DataFldr, G_TargetFldr
			String Target = G_Target, TargetAge = G_TargetAge, TargetFldr = G_TargetFldr 
			String Data = G_Data, DataAge = G_DataAge, DataFldr = G_DataFldr		
			Prompt TargetFldr, "Target Folder:", popup, FolderList( "*" ) 
			Prompt DataFldr, "Data Folder:", popup, FolderList( "*" ) 			
			DoPrompt "CODD_TuningSetUp", TargetFldr, DataFldr
			G_TargetFldr = TargetFldr; G_DataFldr = DataFldr
			AbortOnValue V_Flag, 0
			DFREF TargetDF = $TargetFldr
			DFREF DataDF = $DataFldr
		SetDataFolder TargetDF
			Prompt Target, "Select Target Data", popup, SortList( WaveList( "*", ";", "" ) )
			Prompt TargetAge, "Select Target Age", popup, SortList( WaveList( "*", ";", "" ) )
			DoPrompt "CODD_TuningSetUp", Target, TargetAge
			G_Target = Target, G_TargetAge = TargetAge
			AbortOnValue V_Flag, 0
			WAVE TargetWv = $Target
			WAVE TargetAgeWv = $TargetAge
		SetDataFolder DataDF
			Prompt Data, "Select Data", popup, SortList( WaveList( "*", ";", "" ), ";", 16 )
			Prompt DataAge, "Select Data Depth or Age", popup, SortList( WaveList( "*", ";", "" ), ";", 16 )
			DoPrompt "CODD_TuningSetUp", Data, DataAge
			G_Data = Data, G_DataAge = DataAge
			AbortOnValue V_Flag, 0
			WAVE DataWv = $Data
			WAVE DataAgeWv = $DataAge
			If( !StringMatch( FirstPart( Data ), FirstPart( DataAge ) ) )
				ABORT "Data are from " + Firstpart( Data ) + " and Ages are from " + FirstPart( DataAge ) 
			Endif
		NewDataFolder/O root:Xtras
		SetDataFolder root:	
			If( WinType( "TuningGraph" ) < 1 )
				Display/N = TuningGraph /W=(504,45,1899,852)/L=DataAxis DataWv vs DataAgeWv
				ModifyGraph axisEnab(DataAxis)={0,0.25},freePos(DataAxis)=0
				SetAxis/A/R DataAxis
				Label DataAxis "\\Z24\\f01Data"
				AppendTograph/L=TargetAxis TargetWv vs TargetAgeWv
				ModifyGraph axisEnab(TargetAxis)={0.25,0.5},freePos(TargetAxis)=0
				SetAxis/A/R TargetAxis
				Label TargetAxis "\\Z24\\f01Target"
				AppendTograph/L=MatchAxis TargetWv vs TargetAgeWv
				ModifyGraph axisEnab(MatchAxis)={0.5,0.75},freePos(MatchAxis)=0
				SetAxis/A/R MatchAxis
				Label MatchAxis "\\Z24\\f01Match"
				ModifyGraph lblPosMode = 1, lsize = 2, mirror = 2
				ShowInfo
				ModifyGraph lsize = 2
				Set_Cursors_Black()		
				Cursor/P A $Target 10; Cursor/P B $Data 10
			Else
				DoWindow/F TuningGraph
				ABORT
			EndIf
			
end				
			WAVE CoreTies, TargetTies
//		NewDataFolder/O/S root:Xtras
			WAVE CoreTieVals, TargetTieVals, TieNumber
			If( WaveExists( CoreTies ) )
				AppendToGraph/L=DataAxis :Xtras:CoreTieVals vs CoreTies
//				AppendToGraph/L = MatchAxis :Xtras:TargetTieVals vs TargetTies
				AppendToGraph/L = TargetAxis :Xtras:TargetTieVals vs TargetTies
				ModifyGraph mode(CoreTieVals)=3,textMarker(CoreTieVals)={:Xtras:TieNumber,"default",0,0,5,0,10}
				ModifyGraph mode(TargetTieVals)=3,textMarker(TargetTieVals)={:Xtras:TieNumber,"default",0,0,5,0,10}
//				ModifyGraph mode(TargetTieVals#1)=3,textMarker(TargetTieVals#1)={:Xtras:TieNumber,"default",0,0,5,0.00,0.00}
				ModifyGraph minor(bottom)=1, msize(CoreTieVals)=5, msize(TargetTieVals)=5
			EndIf
		SetDataFolder root:	
	End