#pragma rtGlobals=3		// Use modern global access method.
	
	Function Calculate_CCSF_Wave( )
		SetDataFolder root:
			String/G G_Hole, G_Technique, G_DepthTypeIn, G_DepthTypeOut
			String Hole = G_Hole, Technique = G_Technique, DepthTypeIn = G_DepthTypeIn, DepthTypeOut = G_DepthTypeOut
			String Site, Folder
			Prompt Hole, "Hole"
			Prompt Technique, "Technique (e.g. GRA, RSC,MS, XRF etc):"
			Prompt DepthTypeIn, "Input Depth Data Type (e.g. CSF, CSFA, mbsf, etc):"
			Prompt DepthTypeOut, "Output Depth Data Type (e.g. CCSF, CCSFA, mcd, rmcd, etc):"
			DoPrompt "Calculate_CCSF_Wave", Hole, Technique, DepthTypeIn, DepthTypeOut
			G_Hole = Hole; G_Technique = Technique; G_DepthTypeIn = DepthTypeIn; G_DepthTypeOut = DepthTypeOut
			AbortOnValue V_Flag, 0
			Calculate_CCSF_Wave_F( Hole, Technique, DepthTypeIn, DepthTypeOut )
			Print "Calculate_CCSF_Wave_F( \"" + Hole + "\", \"" + Technique + "\", \"" + DepthTypeIn + "\", \"" + DepthTypeOut + "\" )"
	End

-------------------------------------------------------------------------------------------------------------------------------------	
	
	Function Calculate_CCSF_Wave_F( Hole, Technique, DepthTypeIn, DepthTypeOut )
		String Hole, Technique, DepthTypeIn, DepthTypeOut
		SetDataFolder root:
			Hole = UpperStr( Hole )
			String Site, Folder
			Site = RemoveEnding( Hole )
			Folder = Site + "_" + Technique
			PauseUpdate;
			CheckOffsets_CoreNumbers( Hole )
			CheckEqualWaveLengthsHole( Hole, Technique )
			If( Exists( Hole + "_Offsets" ) ) // Checks to see if the offset wave exists
				WAVE Offsets = $Hole + "_Offsets"
			Else
				Print "Cannot find Offset wave " + Hole + "_Offsets in root:"
				ABORT "Cannot find Offset wave " + Hole + "_Offsets in root:"
			EndIf
			If( !DataFolderExists( Folder ) ) // Checks to see if the folder eists
				Print "\rCannot find folder " + Folder + " in root:\r"
				ABORT "Cannot find folder " + Folder + " in root:"
			EndIf
			Remove_NaNs_F( Hole, Technique )
		SetDataFolder $Folder
			If( !Exists( Hole + "_" + Technique + "_" + DepthTypeIn ) )	// Checks to see if the CSF/mbsf wave is present.
				SetDataFolder root:
				Print "\rThere is no " + DepthTypeIn + " wave for Hole " + Hole + " in folder " + Folder + "\r"
				ABORT "There is no " + DepthTypeIn + " wave for Hole " + Hole + " in folder " + Folder
			EndIf
			Check4DoubleUnderscoresInNames( )
			WAVE CSFWave = $Hole + "_" + Technique + "_" + DepthTypeIn
			Duplicate/O CSFWave $Hole + "_" + Technique + "_" + DepthTypeOut
			WAVE CCSFWave = $Hole + "_" + Technique + "_" + DepthTypeOut
			Note CCSFWave note( Offsets )
			WaveStats/Q CSFWave
			If( V_NumNaNs )		// Checks to see if there are NaN's in the data which will generate an eror message ( but the function will work ).
				Print "\rThere are blanks in the CSF/mbsf data for hole " + Hole + "_" + Technique + "\r"
				DoAlert 0, "There are blanks in the CSF/mbsf data for hole " + Hole + "_" + Technique + "\r  The function will work but may generate\r  an \"index out of range\" error message.\r\rDid you Add_NaNs and forget to Remove_NaNs before calculating CCSF/mcd?"
			EndIf
			If( Exists( Hole + "_" + Technique + "_Core" ) )
				WAVE CoreWave = $Hole + "_" + Technique + "_Core" 
			Else
				SetDataFolder root:
				Print "Cannot find Core wave " + Hole + "_" + Technique + "_Core\r in folder " + Folder
				ABORT "Cannot find Core wave " + Hole + "_" + Technique + "_Core\r in folder " + Folder
			EndIf
			CCSFWave += Offsets[ CoreWave ]
		SetDataFolder root:
	End


	
	
//	Function Calculate_CCSF_Wave( )
		SetDataFolder root:
			String/G G_Hole, G_Technique
			String Hole = G_Hole, Technique = G_Technique
			String Site, Folder
			Prompt Hole, "Hole"
			Prompt Technique, "Technique (e.g. GRA, RSC,MS, XRF etc):"
			DoPrompt "Calculate_CCSF_Wave", Hole, Technique; AbortOnValue V_Flag, 0
			Calculate_CCSF_Wave_F( Hole, Technique )
			Print "Calculate_CCSF_Wave_F( \"" + Hole + "\", \"" + Technique + "\" ) "
	End

-------------------------------------------------------------------------------------------------------------------------------------	
	
//	Function Calculate_CCSF_Wave_F( Hole, Technique )
		String Hole, Technique
		SetDataFolder root:
			String/G G_Hole, G_Technique
			String Site, Folder
			PauseUpdate;
			If( Exists( Hole + "_Offsets" ) ) // Checks to see if the offset wave exists
				WAVE Offsets = $Hole + "_Offsets"
			Else
				Print "Cannot find Offset wave " + Hole + "_Offsets in root:"
				ABORT "Cannot find Offset wave " + Hole + "_Offsets in root:"
			EndIf
			Site = RemoveEnding( Hole )
			Folder = Site + "_" + Technique
			If( !DataFolderExists( Folder ) ) // Checks to see if the folder eists
				Print "\rCannot find folder " + Folder + " in root:\r"
				ABORT "Cannot find folder " + Folder + " in root:"
			EndIf
			Remove_NaNs_F( Hole, Technique )
		SetDataFolder $Folder
			If( !Exists( Hole+"_"+Technique+"_CSF" ) && !Exists( Hole+"_"+Technique+"_mbsf" ))	// Checks to see if the CSF/mbsf wave is present.
				SetDataFolder root:
				Print "\rThere is no CSF/mbsf wave for Hole " + Hole + " in folder " + Folder + "\r"
				ABORT "There is no CSF/mbsf wave for Hole " + Hole + " in folder " + Folder
			EndIf
			If( Exists( Hole+"_"+Technique+"_CSF" ) ) // Makes CCSF wave for CSF instance
				WAVE CSFWave = $Hole+"_"+Technique+"_CSF"
				Duplicate/O CSFWave $Hole+"_"+Technique+"_CCSF"
				WAVE CCSFWave = $Hole+"_"+Technique+"_CCSF"
			Else																		 // Makes mcd wave for mbsf instance
				WAVE CSFWave = $Hole+"_"+Technique+"_mbsf"
				Duplicate/O CSFWave $Hole+"_"+Technique+"_mcd"
				WAVE CCSFWave = $Hole+"_"+Technique+"_mcd"
			EndIf
			WaveStats/Q CSFWave
			If( V_NumNaNs )		// Checks to see if there are NaN's in the data which will generate an eror message ( but the function will work ).
				Print "\rThere are blanks in the CSF/mbsf data.\r  The function will work but may generate\r  an \"index out of range\" error message.\r\rDid you Add_NaNs and forget to Remove_NaNs before calculating CCSF/mcd?"
				DoAlert 0, "There are blanks in the CSF/mbsf data.\r  The function will work but may generate\r  an \"index out of range\" error message.\r\rDid you Add_NaNs and forget to Remove_NaNs before calculating CCSF/mcd?"
			EndIf
			If( Exists( Hole + "_" + Technique + "_Core" ) )
				WAVE CoreWave = $Hole + "_" + Technique + "_Core" 
			Else
				SetDataFolder root:
				Print "Cannot find Core wave " + Hole + "_" + Technique + "_Core\r in folder " + Folder
				ABORT "Cannot find Core wave " + Hole + "_" + Technique + "_Core\r in folder " + Folder
			EndIf
			CCSFWave += Offsets[ CoreWave ]
		SetDataFolder root:
	End

