﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function CreateHoleCoreImageProfiles()
		SetDataFolder root:
			Variable i, CoreNumber
			String/G G_Hole, G_DepthType
			String Hole = G_Hole, DepthType = G_DepthType, ImageName, Site, HoleLetter, ImageNote
			Prompt Hole, "Hole ( e.g. U1333A ):"
			Prompt DepthType, "DepthType ( e.g. mbsf or CSF ):"
			DoPrompt "CreateHoleCoreImageProfiles", Hole, DepthType
			G_Hole = Hole, G_DepthType = DepthType
			AbortOnValue V_Flag, 0
			Site = RemoveEnding( Hole )
			HoleLetter = Hole[ StrLen( Site ) ]
			NewDataFolder/O $Site + "_Profiles" // Creates a data folder for the profiles
			DFREF ProfileFldr = $Site + "_Profiles" // Creates a reference to the profile folder
			Make/O/N = 0 ProfileFldr:$Hole + "_Profiles_" + DepthType, ProfileFldr:$Hole + "_Profiles_Core" // Creates waves in the profile folder
			Make/O/N = 0 ProfileFldr:$Hole + "_Profiles_R", ProfileFldr:$Hole + "_Profiles_G" // Creates waves in the profile folder
			Make/O/N = 0 ProfileFldr:$Hole + "_Profiles_B", ProfileFldr:$Hole + "_Profiles_H" // Creates waves in the profile folder
			Make/O/N = 0 ProfileFldr:$Hole + "_Profiles_S", ProfileFldr:$Hole + "_Profiles_L" // Creates waves in the profile folder
			WAVE DepthProfile = ProfileFldr:$Hole + "_Profiles_" + DepthType, CoreProfile = ProfileFldr:$Hole + "_Profiles_Core" // Creates references to profile waves
			WAVE RedProfile = ProfileFldr:$Hole + "_Profiles_R", GreenProfile = ProfileFldr:$Hole + "_Profiles_G" // Creates references to profile waves
			WAVE BlueProfile = ProfileFldr:$Hole + "_Profiles_B", HueProfile = ProfileFldr:$Hole + "_Profiles_H" // Creates references to profile waves
			WAVE SaturationProfile = ProfileFldr:$Hole + "_Profiles_S", LuminanceProfile = ProfileFldr:$Hole + "_Profiles_L" // Creates references to profile waves
			DFREF ImageFldr = $Hole + "_S2" // Creates reference to the proper image data folder
		SetDataFolder ImageFldr
			String ImageList = SortList( WaveList( "*", ";", "" ) )
			For( i = 0; i < ItemsInList( ImageList, "," ); i += 1 ) // This loop runs through the images and concatenates each profile to the previous one.
//			For( i = 0; i < 3; i += 1 ) // This loop runs through the images and concatenates each profile to the previous one.
				ImageName = StringFromList( i, ImageList, ";" )
				CoreNumber = ImageCore( ImageName )
				WAVE Image = $ImageName
				WAVE Image = ImageFldr:$ImageName
				ImageNote = note( Image )
			  Image_CCSF_2_CSF_F( Hole, "S2" )	
				ImageProfile_F( Image ) // this is a CODD function producing R, G,B, H, S, L and depth profiles from a single image
				WAVE DepthWv, R_Profile, G_Profile, B_Profile, H_Profile, S_Profile, L_Profile
				Duplicate/O DepthWv CoreWv
				CoreWv = CoreNumber
				Concatenate/NP { CoreWv }, CoreProfile
				Concatenate/NP { DepthWv }, DepthProfile
				Concatenate/NP { R_Profile }, RedProfile
				Concatenate/NP { G_Profile }, GreenProfile
				Concatenate/NP { B_Profile }, BlueProfile
				Concatenate/NP { H_Profile }, HueProfile
				Concatenate/NP { S_Profile }, SaturationProfile
				Concatenate/NP { L_Profile }, LuminanceProfile
				If( StringMatch( ImageNote, "mcd/CCSF scale" ) )
					Image_CSF_2_CCSF_F( Hole, "S2" )
				Endif
			EndFor	
			Make/T/O/N = ( NumPnts( DepthProfile ) ) ProfileFldr:$Hole + "_Profiles_Site", ProfileFldr:$Hole + "_Profiles_Hole"
			WAVE/T SiteWv = ProfileFldr:$Hole + "_Profiles_Site", HoleWv = ProfileFldr:$Hole + "_Profiles_Hole"
			SiteWv = Site
			HoleWv = HoleLetter
			KillWaves DepthWv, CoreWv, R_Profile, G_Profile, B_Profile, H_Profile, S_Profile, L_Profile
		SetDataFolder root:
	End		




//	Function CreateHoleCoreImageProfiles()
		SetDataFolder root:
			Variable i, CoreNumber
			String/G G_Hole, G_DepthType
			String Hole = G_Hole, DepthType = G_DepthType, ImageName, Site, HoleLetter
			Prompt Hole, "Hole ( e.g. U1333A ):"
			Prompt DepthType, "DepthType ( e.g. mbsf or CSF ):"
			DoPrompt "CreateHoleCoreImageProfiles", Hole, DepthType
			G_Hole = Hole, G_DepthType = DepthType
			AbortOnValue V_Flag, 0
			Site = RemoveEnding( Hole )
			HoleLetter = Hole[ StrLen( Site ) ]
			NewDataFolder/O $Site + "_Profiles" // Creates a data folder for the profiles
			DFREF ProfileFldr = $Site + "_Profiles" // Creates a reference to the profile folder
	//		Make/T/O/N = 0 ProfileFldr:$Hole + "_Profiles_Site, ProfileFldr:$Hole + "_Profiles_Hole" // Creates waves in the profile folder
			Make/O/N = 0 ProfileFldr:$Hole + "_Profiles_" + DepthType, ProfileFldr:$Hole + "_Profiles_Core" // Creates waves in the profile folder
			Make/O/N = 0 ProfileFldr:$Hole + "_Profiles_R", ProfileFldr:$Hole + "_Profiles_G" // Creates waves in the profile folder
			Make/O/N = 0 ProfileFldr:$Hole + "_Profiles_B", ProfileFldr:$Hole + "_Profiles_H" // Creates waves in the profile folder
			Make/O/N = 0 ProfileFldr:$Hole + "_Profiles_S", ProfileFldr:$Hole + "_Profiles_L" // Creates waves in the profile folder
			WAVE DepthProfile = ProfileFldr:$Hole + "_Profiles_" + DepthType, CoreProfile = ProfileFldr:$Hole + "_Profiles_Core" // Creates references to profile waves
			WAVE RedProfile = ProfileFldr:$Hole + "_Profiles_R", GreenProfile = ProfileFldr:$Hole + "_Profiles_G" // Creates references to profile waves
			WAVE BlueProfile = ProfileFldr:$Hole + "_Profiles_B", HueProfile = ProfileFldr:$Hole + "_Profiles_H" // Creates references to profile waves
			WAVE SaturationProfile = ProfileFldr:$Hole + "_Profiles_S", LuminanceProfile = ProfileFldr:$Hole + "_Profiles_L" // Creates references to profile waves
			DFREF ImageFldr = $Hole + "_S2" // Creates reference to the proper image data folder
				// THe next line creates a list of image waves in the data folder 
			String ImageList = DataFolderDir( 2, ImageFldr )[ 6, StrLen(DataFolderDir( 2, ImageFldr ) ) - 3 ]
			For( i = 0; i < ItemsInList( ImageList, "," ); i += 1 ) // This loop runs through the images and concatenates each profile to the previous one.
				ImageName = StringFromList( i, ImageList, "," )
				CoreNumber = ImageCore( ImageName )
				WAVE Image = ImageFldr:$ImageName
				ImageProfile_F( Image ) // this is a CODD function producing R, G,B, H, S, L and depth profiles from a single image
				WAVE DepthWv, R_Profile, G_Profile, B_Profile, H_Profile, S_Profile, L_Profile
				Duplicate/O DepthWv CoreWv
				CoreWv = CoreNumber
				Concatenate/NP { CoreWv }, CoreProfile
				Concatenate/NP { DepthWv }, DepthProfile
				Concatenate/NP { R_Profile }, RedProfile
				Concatenate/NP { G_Profile }, GreenProfile
				Concatenate/NP { B_Profile }, BlueProfile
				Concatenate/NP { H_Profile }, HueProfile
				Concatenate/NP { S_Profile }, SaturationProfile
				Concatenate/NP { L_Profile }, LuminanceProfile
			EndFor	
			Make/T/O/N = ( NumPnts( DepthProfile ) ) ProfileFldr:$Hole + "_Profiles_Site", ProfileFldr:$Hole + "_Profiles_Hole"
			WAVE/T SiteWv = ProfileFldr:$Hole + "_Profiles_Site", HoleWv = ProfileFldr:$Hole + "_Profiles_Hole"
			SiteWv = Site
			HoleWv = HoleLetter
			KillWaves DepthWv, CoreWv, R_Profile, G_Profile, B_Profile, H_Profile, S_Profile, L_Profile
	End		