﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function InitializeOffsetWaves()				//Will now make an offset "Note" wave to append information to about the offset. Update 04.07.2018 
		SetDataFolder root:
			String/G G_Hole
			String Hole = G_Hole, HoleList
			Variable/G  G_InitialOffset
			Variable HighestNumberCore, InitialOffset = G_InitialOffset
			DoAlert/T = "InitializeOffsetWaves" 1, "WARNING! This function will overwrite any existing offsets for the specified Hole. It is used only to set up new offset waves.\r\rDo you want to continue?"
			If( V_Flag != 1 )
				ABORT
			Endif
			NewDataFolder/O root:Xtras														//Makes "Xtras" folder if it is not there
			NewDataFolder/O root:Xtras:Splicing											//Makes "splicing" subfolder
			DFREF SplicingFldr = root:Xtras:Splicing									//Defined DFreference for the Splicing subfolder
			IF(WaveExists(root:Xtras:Splicing:History_Offset_Changes)==0)
				Make/o/N=(1,6)/T root:Xtras:Splicing:History_Offset_Changes					//Makes a "history matrix" where changes to the offset are recorded. 
				WAVE/T History =	 $"root:Xtras:Splicing:History_Offset_Changes"					
				SetDimLabel 1,0, 'Timestamp', History
				SetDimLabel 1,1, 'Hole', History
				SetDimLabel 1,2, 'Core', History
				SetDimLabel 1,3, 'Offset change', History
				SetDimLabel 1,4, 'Applied to', History
				SetDimLabel 1,5, 'OffsetNote', History
				Edit/N=History_Offset_Changes History.ld			
			EndIf		
			Do
				Prompt Hole, "Hole"
				Prompt InitialOffset, "Set Initial Constant Cumulative Offset ( 1 m is recommended )" // User may begin with a constant offset for each core to avoid overlaps in the data
				DoPrompt "InitializeOffsetWaves" , Hole, InitialOffset
				Hole = UpperStr( Hole )
				G_Hole = Hole; G_InitialOffset = InitialOffset
				AbortOnValue V_Flag, 0
				WAVE Matrix = $Hole + "_Coring_Matrix"
				WaveStats/Q Matrix 
				HighestNumberCore = V_MaxRowLoc
				Make/O/N = ( HighestNumberCore + 1 ) $Hole + "_Offsets" 			// Forms or overwrites an offset wave for input hole 
				WAVE OffsetWv = $Hole + "_Offsets"  										// OffsetWv is the offset wave for the input Hole
				SetDataFolder SplicingFldr
				Make/T/O/N = ( HighestNumberCore + 1 ) $Hole + "_OffsetsNote"	// Forms or overwrites an offset note wave for input hole (added 13.06.2018)
				WAVE OffsetWvNote = $Hole + "_OffsetsNote" 							// OffsetWvNote is the offset note wave for the input Hole (added 13.06.2018) 
				SetDataFolder root:
				HoleList = WaveList( "*Offsets", ",", "" ) 							// Sets a list of offset waves ( can be a zero length list )
				If( StrLen( WinList( "OffsetTable", "", "" ) )  == 0 ) 			// If there is no offset table open this "If" makes a new table
					EXECUTE "Edit/N = OffsetTable as \"OffsetTable\" " 				// If there is no offset table open this line makes a new table
				EndIf
					DoWindow/F OffsetTable  													// Moves the offset table to the front
					AppendToTable OffsetWv  													// Adds/overwrites the input Hole offset wave to the table
					AppendToTable OffsetWvNote  											// Adds/overwrites the input Hole offset note wave to the table (added 13.06.2018)
					OffsetWv = ( x - 1 ) * InitialOffset 								// Calculates the initial offset
					OffsetWv[ 0 ] = NaN	  													// Since the point number is the same as the core number, point 0 is always NaN			
				DoAlert/T = "InitializeOffsetTable" 1, "Enter Another Hole?"
			While( V_Flag < 2 )
			ModifyTable format=3,digits=2
	End

---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

	Function InitializeReviseSplice()				//Run now make an offset "Note" wave to append information to about the offset. Update 04.07.2018 
		SetDataFolder root:
			String/G G_Hole
			String Hole = G_Hole, HoleList
			Variable HighestNumberCore
			DoAlert/T = "InitializeReviseSplice" 1, "WARNING! This function will overwrite any existing offset note waves for the specified Hole. It is used only to set up new offset note wave.\r\rDo you want to continue?"
			If( V_Flag != 1 )
				ABORT
			Endif
			NewDataFolder/O root:Xtras														//Makes "Xtras" folder if it is not there
			NewDataFolder/O root:Xtras:Splicing											//Makes "splicing" subfolder
			DFREF SplicingFldr = root:Xtras:Splicing									//Defined DFreference for the Splicing subfolder
			IF(WaveExists(root:Xtras:Splicing:History_Offset_Changes)==0)
				Make/o/N=(1,6)/T root:Xtras:Splicing:History_Offset_Changes					//Makes a "history matrix" where changes to the offset are recorded. 
				WAVE/T History =	 $"root:Xtras:Splicing:History_Offset_Changes"					
				SetDimLabel 1,0, 'Timestamp', History
				SetDimLabel 1,1, 'Hole', History
				SetDimLabel 1,2, 'Core', History
				SetDimLabel 1,3, 'Offset change', History
				SetDimLabel 1,4, 'Applied to', History
				SetDimLabel 1,5, 'OffsetNote', History
				Edit/N=History_Offset_Changes History.ld			
			EndIf
			Do
				Prompt Hole, "Hole"
				DoPrompt "InitializeReviseSplice" , Hole
				Hole = UpperStr( Hole )
				G_Hole = Hole
				AbortOnValue V_Flag, 0
				WAVE Matrix = $Hole + "_Coring_Matrix"
				WaveStats/Q Matrix 
				HighestNumberCore = V_MaxRowLoc
				SetDataFolder SplicingFldr
				Make/T/O/N = ( HighestNumberCore + 1 ) $Hole + "_OffsetsNote" 	// Forms or overwrites an offset note wave for input hole (added 13.06.2018)
				WAVE OffsetWvNote = $Hole + "_OffsetsNote" 							// OffsetWvNote is the offset note wave for the input Hole (added 13.06.2018) 
				SetDataFolder root:
				HoleList = WaveList( "*Offsets", ",", "" ) 							// Sets a list of offset waves ( can be a zero length list )
				If( StrLen( WinList( "OffsetTable", "", "" ) )  == 0 ) 			// If there is no offset table open this "If" makes a new table
					EXECUTE "Edit/N = OffsetTable as \"OffsetTable\" "				// If there is no offset table open this line makes a new table
				EndIf
				WAVE OffsetWv = $Hole + "_Offsets"  										// OffsetWv is the offset wave for the input Hole
				DoWindow/F OffsetTable  														// Moves the offset table to the front
				AppendToTable OffsetWv 	 													// Adds/overwrites the input Hole offset wave to the table
				AppendToTable OffsetWvNote 													// Adds/overwrites the input Hole offset note wave to the table (added 13.06.2018)
				DoAlert/T = "InitializeOffsetTable" 1, "Enter Another Hole?"
			While( V_Flag < 2 )
			ModifyTable format=3,digits=2
			
	End
	
	
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


//	Function InitializeOffsetWaves()				//Will now make an offset "Note" wave to append information to about the offset. 
		SetDataFolder root:
			String/G G_Hole
			String Hole = G_Hole, HoleList
			Variable/G G_HighestNumberCore, G_InitialOffset
			Variable HighestNumberCore = G_HighestNumberCore, InitialOffset = G_InitialOffset
			DoAlert/T = "InitializeOffsetWaves" 1, "WARNING! This function will overwrite any existing offsets for the specified Hole. It is used only to set up new offset waves.\r\rDo you want to continue?"
			If( V_Flag != 1 )
				ABORT
			Endif
			Do
				Prompt Hole, "Hole"
				Prompt HighestNumberCore, "Core Number of the Deepest Core (e.g. 1, 12, 20, etc.)"
				Prompt InitialOffset, "Set Initial Constant Cumulative Offset ( m )" // User may begin with a constant offset for each core to avoid overlaps in the data
				DoPrompt "InitializeOffsetWaves" , Hole, HighestNumberCore, InitialOffset
				Hole = UpperStr( Hole )
				G_Hole = Hole; G_HighestNumberCore = HighestNumberCore; G_InitialOffset = InitialOffset
				AbortOnValue V_Flag, 0
				Make/O/N = ( HighestNumberCore + 1 ) $Hole + "_Offsets" // Forms or overwrites an offset wave for input hole 
				Make/T/O/N = ( HighestNumberCore + 1 ) $Hole + "_OffsetsNote" // Forms or overwrites an offset note wave for input hole (added 13.06.2018)
				WAVE OffsetWv = $Hole + "_Offsets" // OffsetWv is the offset wave for the input Hole
				WAVE OffsetWvNote = $Hole + "_OffsetsNote" // OffsetWvNote is the offset note wave for the input Hole (added 13.06.2018) 
				HoleList = WaveList( "*Offsets", ",", "" ) // Sets a list of offset waves ( can be a zero length list )
				If( StrLen( WinList( "OffsetTable", "", "" ) )  == 0 ) // If there is no offset table open this "If" makes a new table
					EXECUTE "Edit/N = OffsetTable as \"OffsetTable\" " // If there is no offset table open this line makes a new table
				EndIf
					DoWindow/F OffsetTable // Moves the offset table to the front
					AppendToTable OffsetWv // Adds/overwrites the input Hole offset wave to the table
					AppendToTable OffsetWvNote // Adds/overwrites the input Hole offset note wave to the table (added 13.06.2018)
					OffsetWv = ( x - 1 ) * InitialOffset // Calculates the initial offset
					OffsetWv[ 0 ] = NaN	 // Since the point number is the same as the core number, point 0 is always NaN			
				DoAlert/T = "InitializeOffsetTable" 1, "Enter Another Hole?"
			While( V_Flag < 2 )
			ModifyTable format=3,digits=2
	End

---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

//Original function
	
//	Function InitializeOffsetWaves()
		SetDataFolder root:
			String/G G_Hole
			String Hole = G_Hole, HoleList
			Variable/G G_HighestNumberCore, G_InitialOffset
			Variable HighestNumberCore = G_HighestNumberCore, InitialOffset = G_InitialOffset
			DoAlert/T = "InitializeOffsetWaves" 1, "WARNING! This function will overwrite any existing offsets for the specified Hole. It is used only to set up new offset waves.\r\rDo you want to continue?"
			If( V_Flag != 1 )
				ABORT
			Endif
			Do
				Prompt Hole, "Hole"
				Prompt HighestNumberCore, "Core Number of the Deepest Core (e.g. 1, 12, 20, etc.)"
				Prompt InitialOffset, "Set Initial Constant Cumulative Offset ( m )" // User may begin with a constant offset for each core to avoid overlaps in the data
				DoPrompt "InitializeOffsetWaves" , Hole, HighestNumberCore, InitialOffset
				Hole = UpperStr( Hole )
				G_Hole = Hole; G_HighestNumberCore = HighestNumberCore; G_InitialOffset = InitialOffset
				AbortOnValue V_Flag, 0
				Make/O/N = ( HighestNumberCore + 1 ) $Hole + "_Offsets" // Forms or overwrites an offset wave for input hole
				WAVE OffsetWv = $Hole + "_Offsets" // OffsetWv is the offset wave for the input Hole
				HoleList = WaveList( "*Offsets", ",", "" ) // Sets a list of offset waves ( can be a zero length list )
				If( StrLen( WinList( "OffsetTable", "", "" ) )  == 0 ) // If there is no offset table open this "If" makes a new table
					EXECUTE "Edit/N = OffsetTable as \"OffsetTable\" " // If there is no offset table open this line makes a new table
				EndIf
					DoWindow/F OffsetTable // Moves the offset table to the front
					AppendToTable OffsetWv // Adds/overwrites the input Hole offset wave to the table
					OffsetWv = ( x - 1 ) * InitialOffset // Calculates the initial offset
					OffsetWv[ 0 ] = NaN	 // Since the point number is the same as the core number, point 0 is always NaN			
				DoAlert/T = "InitializeOffsetTable" 1, "Enter Another Hole?"
			While( V_Flag < 2 )
			ModifyTable format=3,digits=2
	End
