﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function JANUS_SpliceTieLoader()
		SetDataFolder root:
			Variable i
			String Hole
			WAVE/Z/T Hole_Start, Hole_End, Relation, CT
			WAVE/Z Leg, Sort_Key, Site
			WAVE/Z Core_Start, Sec__Start, Int__Start, MBSF_Start, MCD_Start
			WAVE/Z Core_End, Sec__End, Int__End, MBSF_End, MCD_End
			If( !WaveExists( MBSF_Start ) )
				Print "I can't find the datawave \"MBSF_Start\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are Splice Tie data from JANUS - not Splice Interval data?"
				ABORT "I can't find the datawave \"MBSF_Start\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are Splice Tie data from JANUS - not Splice Interval data?"
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "MBSF_Start", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			String SiteName = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteName + "_Splice_Ties"
			DFREF SpliceTieFolder = $SiteName + "_Splice_Ties"
			For( i = 0; i < NumPnts( Hole_Start ); i += 1 ) // These 2 "For loops" get rid of blank characters in the Hole columns from the JANUS database, e.g. changes " A" to "A"
				Hole = Hole_Start[i]
				Hole_Start[i] = Hole[ Strlen( Hole ) - 1  ]
			EndFor
			For( i = 0; i < NumPnts( Hole_End ); i += 1 )
				Hole = Hole_End[i]
				Hole_End[i] = Hole[ Strlen( Hole ) - 1  ]
			EndFor
		SetDataFolder	SpliceTieFolder
			Duplicate/O/T Hole_Start Hole_Bottom
			Duplicate/O Core_Start Core_Bottom
			Duplicate/O Sec__Start Section_Bottom
			Duplicate/O Int__Start Interval_Bottom
			Duplicate/O MBSF_Start CSF_Bottom
			Duplicate/O MCD_Start CCSF_Bottom
			
			Duplicate/O/T Hole_End Hole_Top
			Duplicate/O Core_End Core_Top
			Duplicate/O Sec__End Section_Top
			Duplicate/O Int__End Interval_Top
			Duplicate/O MBSF_End CSF_Top
			Duplicate/O MCD_End CCSF_Top

			Duplicate/O/T Relation Tie
			Duplicate/O/T CT Type_Top, Type_Bottom, Site_Top, Site_Bottom
			Site_Bottom = SiteName
			Site_Top = SiteName
			Variable BottomPoint = NumPnts( Core_Bottom ) - 1, TopPoint = NumPnts( Core_Top ) - 1
			Type_Bottom[ BottomPoint ] = Type_Bottom[ ( BottomPoint - 1 ) ]
			String TopWaveList = WaveList( "*Top", ";", "" )
			For( i = 0; i < ItemsInList( TopWaveList ); i += 1 )
				ReDimension/N = ( TopPoint ) $StringFromList( i, TopWaveList )
			EndFor	
		SetDataFolder root:
			EmptyJANUSDataTable()
			KillWaves Hole_Start, Hole_End, Relation, CT
			KillWaves Leg, Site, Sort_Key 
			KillWaves Core_Start, Sec__Start, Int__Start, MBSF_Start, MCD_Start
			KillWaves Core_End, Sec__End, Int__End, MBSF_End, MCD_End
			Splice_Tie_Table_F( SiteName )			
	End












	
	
//	Function JANUS_SpliceIntervalLoader()
		SetDataFolder root:
			WAVE/Z Leg, Site, MCD_Top, MCD_Bot
			WAVE/Z/T H
			If( !WaveExists( MCD_Top ) )
				Print "I can't find the datawave \"MCD_Top\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are Splice Interval data from JANUS - not Splice Tie data?"
				ABORT "I can't find the datawave \"MCD_Top\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are Splice Interval data from JANUS - not Splice Tie data?"
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "MCD_Top", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			If( StringMatch( H[ NumPnts( H ) -1 ], "" ) )
				Print "\r\rThere is a problem with the Hole data wave \"H\".\rThe last entry is missing and the others are probably shifted one line."
				Print "\rThis is a bug that has been reported to IODP."
				Print "\rThe easiest fix is to use the splice tie format download to create\r\t the splice and then convert from Splice_Ties to Splice_Intervals." 
				DoAlert/T = "Problem with Hole designators" 1, "Read the problem description in the History window.\r\rDo you want to continue."
				AbortOnValue V_Flag == 2, 0
			Endif
			String SiteName = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteName + "_Splice_Intervals"
			DFREF SpliceIntFldr = $SiteName + "_Splice_Intervals"
			CSI_from_List_F( "root:", "CCSF", SiteName, "H", "MCD_Top", "N" )
		SetDataFolder CSI_OutPut
			WAVE/T TypeOut,HoleOut,SiteOut
			WAVE CCSFOut,CSFOut,IntervalOut,SectionOut,CoreOut
			Duplicate/O SiteOut SpliceIntFldr:$"Site_Top"
			Duplicate/O HoleOut SpliceIntFldr:$"Hole_Top"
			Duplicate/O CoreOut SpliceIntFldr:$"Core_Top"
			Duplicate/O TypeOut SpliceIntFldr:$"Type_Top"
			Duplicate/O SectionOut SpliceIntFldr:$"Section_Top"
			Duplicate/O IntervalOut SpliceIntFldr:$"Interval_Top"
			Duplicate/O CSFOut SpliceIntFldr:$"CSF_Top"
			Duplicate/O CCSFOut SpliceIntFldr:$"CCSF_Top"
		SetDataFolder root:	
			CSI_from_List_F( "root:", "CCSF", SiteName, "H", "MCD_Bot", "N" )
		SetDataFolder CSI_OutPut
			WAVE/T TypeOut,HoleOut,SiteOut
			WAVE CCSFOut,CSFOut,IntervalOut,SectionOut,CoreOut
			Duplicate/O SectionOut SpliceIntFldr:$"Section_bottom"
			Duplicate/O IntervalOut SpliceIntFldr:$"Interval_bottom"
			Duplicate/O CSFOut SpliceIntFldr:$"CSF_bottom"
			Duplicate/O CCSFOut SpliceIntFldr:$"CCSF_bottom"
		SetDataFolder $"root:" + SiteName + "_Splice_Intervals"
			Make/T/O/N = ( NumPnts( Site ) ) TIE
			TIE = ""
		SetDataFolder root:	
			EmptyJANUSDataTable()
			KillWaves Leg, Site, MCD_Top, MCD_Bot, H
			Killwindow CSICalculations
			KillDataFolder CSI_OutPut
			Splice_Interval_Table_F( SiteName )
	End	

-------------------------------------------------------

//	Function JANUS_SpliceTieLoader()
		SetDataFolder root:
			Variable i
			String Hole
			WAVE/Z/T Hole_Start, Hole_End, Relation, CT
			WAVE/Z Leg, Site, Sort_Key 
			WAVE/Z Core_Start, Sec__Start, Int__Start, MBSF_Start, MCD_Start
			WAVE/Z Core_End, Sec__End, Int__End, MBSF_End, MCD_End
			If( !WaveExists( MBSF_Start ) )
				Print "I can't find the datawave \"MBSF_Start\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are Splice Tie data from JANUS - not Splice Interval data?"
				ABORT "I can't find the datawave \"MBSF_Start\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are Splice Tie data from JANUS - not Splice Interval data?"
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "MBSF_Start", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			String SiteName = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteName + "_Splice_Ties"
			DFREF SpliceTieFldr = $SiteName + "_Splice_Ties"
			For( i = 0; i < NumPnts( Hole_Start ); i += 1 ) // These 2 "For loops" get rid of blank characters in the Hole columns from the JANUS database
				Hole = Hole_Start[i]
				Hole_Start[i] = Hole[ Strlen( Hole ) - 1  ]
			EndFor
			For( i = 0; i < NumPnts( Hole_End ); i += 1 )
				Hole = Hole_End[i]
				Hole_End[i] = Hole[ Strlen( Hole ) - 1  ]
			EndFor
			CSI_from_List_F( "root:", "CCSF", SiteName, "Hole_Start", "MCD_Start", "N" )
		SetDataFolder CSI_OutPut
			WAVE/T TypeOut,HoleOut,SiteOut
			WAVE CCSFOut,CSFOut,IntervalOut,SectionOut,CoreOut
			Duplicate/O SiteOut SpliceTieFldr:$"Site_bottom"
			Duplicate/O HoleOut SpliceTieFldr:$"Hole_bottom"
			Duplicate/O CoreOut SpliceTieFldr:$"Core_bottom"
			Duplicate/O TypeOut SpliceTieFldr:$"Type_bottom"
			Duplicate/O SectionOut SpliceTieFldr:$"Section_bottom"
			Duplicate/O IntervalOut SpliceTieFldr:$"Interval_bottom"
			Duplicate/O CSFOut SpliceTieFldr:$"CSF_bottom"
			Duplicate/O CCSFOut SpliceTieFldr:$"CCSF_bottom"
		SetDataFolder root:	
			CSI_from_List_F( "root:", "CCSF", SiteName, "Hole_End", "MCD_End", "N" )
		SetDataFolder CSI_OutPut
			WAVE/T TypeOut,HoleOut,SiteOut
			WAVE CCSFOut,CSFOut,IntervalOut,SectionOut,CoreOut
			Duplicate/O SiteOut SpliceTieFldr:$"Site_Top"
			Duplicate/O HoleOut SpliceTieFldr:$"Hole_Top"
			Duplicate/O CoreOut SpliceTieFldr:$"Core_Top"
			Duplicate/O TypeOut SpliceTieFldr:$"Type_Top"
			Duplicate/O SectionOut SpliceTieFldr:$"Section_Top"
			Duplicate/O IntervalOut SpliceTieFldr:$"Interval_Top"
			Duplicate/O CSFOut SpliceTieFldr:$"CSF_Top"
			Duplicate/O CCSFOut SpliceTieFldr:$"CCSF_Top"
		SetDataFolder SpliceTieFldr
			Duplicate/O Relation TIE
			WAVE/T Site_Top, Hole_Top, Type_Top
			WAVE Core_Top, Section_Top, Interval_Top, CSF_Top, CCSF_Top
			If( StringMatch( "", Hole_Top[ NumPnts( Hole_Top ) - 1 ] ) ) // This gets rid of the blank "Top" data line to account for the missing first top value in tie point format
				DeletePoints ( NumPnts( Hole_Top ) - 1 ), 1, Site_Top, Hole_Top, Core_Top, Type_Top, Section_Top, Interval_Top, CSF_Top, CCSF_Top, TIE
			EndIf
		SetDataFolder root:	
			EmptyJANUSDataTable()
			KillWaves Hole_Start, Hole_End, Relation, CT
			KillWaves Leg, Site, Sort_Key 
			KillWaves Core_Start, Sec__Start, Int__Start, MBSF_Start, MCD_Start
			KillWaves Core_End, Sec__End, Int__End, MBSF_End, MCD_End
			KillWindow CSICalculations
			KillDataFolder CSI_OutPut
			Splice_Tie_Table_F( SiteName )
	End





//	Function JANUS_SpliceTieLoader()
		SetDataFolder root:
			Variable i
			String Hole
			WAVE/Z/T Hole_Start, Hole_End, Relation, CT
			WAVE/Z Leg, Site, Sort_Key 
			WAVE/Z Core_Start, Sec__Start, Int__Start, MBSF_Start, MCD_Start
			WAVE/Z Core_End, Sec__End, Int__End, MBSF_End, MCD_End
			If( !WaveExists( MBSF_Start ) )
				Print "I can't find the datawave \"MBSF_Start\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are Splice Tie data from JANUS - not Splice Interval data?"
				ABORT "I can't find the datawave \"MBSF_Start\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are Splice Tie data from JANUS - not Splice Interval data?"
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "MBSF_Start", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			String SiteName = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteName + "_Splice_Ties"
			DFREF SpliceTieFldr = $SiteName + "_Splice_Ties"
			For( i = 0; i < NumPnts( Hole_Start ); i += 1 ) // These 2 "For loops" get rid of blank characters in the Hole columns from the JANUS database
				Hole = Hole_Start[i]
				Hole_Start[i] = Hole[ Strlen( Hole ) - 1  ]
			EndFor
			For( i = 0; i < NumPnts( Hole_End ); i += 1 )
				Hole = Hole_End[i]
				Hole_End[i] = Hole[ Strlen( Hole ) - 1  ]
			EndFor
			CSI_from_List_F( "root:", "CCSF", SiteName, "Hole_Start", "MCD_Start", "N" )
		SetDataFolder CSI_OutPut
			WAVE/T TypeOut,HoleOut,SiteOut
			WAVE CCSFOut,CSFOut,IntervalOut,SectionOut,CoreOut
			Duplicate/O SiteOut SpliceTieFldr:$"Site_bottom"
			Duplicate/O HoleOut SpliceTieFldr:$"Hole_bottom"
			Duplicate/O CoreOut SpliceTieFldr:$"Core_bottom"
			Duplicate/O TypeOut SpliceTieFldr:$"Type_bottom"
			Duplicate/O SectionOut SpliceTieFldr:$"Section_bottom"
			Duplicate/O IntervalOut SpliceTieFldr:$"Interval_bottom"
			Duplicate/O CSFOut SpliceTieFldr:$"CSF_bottom"
			Duplicate/O CCSFOut SpliceTieFldr:$"CCSF_bottom"
		SetDataFolder root:	
			CSI_from_List_F( "root:", "CCSF", SiteName, "Hole_End", "MCD_End", "N" )
		SetDataFolder CSI_OutPut
			WAVE/T TypeOut,HoleOut,SiteOut
			WAVE CCSFOut,CSFOut,IntervalOut,SectionOut,CoreOut
			Duplicate/O SiteOut SpliceTieFldr:$"Site_Top"
			Duplicate/O HoleOut SpliceTieFldr:$"Hole_Top"
			Duplicate/O CoreOut SpliceTieFldr:$"Core_Top"
			Duplicate/O TypeOut SpliceTieFldr:$"Type_Top"
			Duplicate/O SectionOut SpliceTieFldr:$"Section_Top"
			Duplicate/O IntervalOut SpliceTieFldr:$"Interval_Top"
			Duplicate/O CSFOut SpliceTieFldr:$"CSF_Top"
			Duplicate/O CCSFOut SpliceTieFldr:$"CCSF_Top"
		SetDataFolder SpliceTieFldr
			Duplicate/O Relation TIE
			WAVE/T Site_Top, Hole_Top, Type_Top
			WAVE Core_Top, Section_Top, Interval_Top, CSF_Top, CCSF_Top
			If( StringMatch( "", Hole_Top[ NumPnts( Hole_Top ) - 1 ] ) ) // This gets rid of the blank "Top" data line to account for the missing first top value in tie point format
				DeletePoints ( NumPnts( Hole_Top ) - 1 ), 1, Site_Top, Hole_Top, Core_Top, Type_Top, Section_Top, Interval_Top, CSF_Top, CCSF_Top, TIE
			EndIf
		SetDataFolder root:	
			EmptyJANUSDataTable()
			KillWaves Hole_Start, Hole_End, Relation, CT
			KillWaves Leg, Site, Sort_Key 
			KillWaves Core_Start, Sec__Start, Int__Start, MBSF_Start, MCD_Start
			KillWaves Core_End, Sec__End, Int__End, MBSF_End, MCD_End
			KillWindow CSICalculations
			KillDataFolder CSI_OutPut
			Splice_Tie_Table_F( SiteName )
	End