﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function PWSJANUSDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "PWSJANUSDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "PWSJANUSDataLoader_F(",CC_Replacement,")"
			PWSJANUSDataLoader_F( CC_Replacement )
	End
	
	Function PWSJANUSDataLoader_F( CC_Replacement )
			Variable CC_Replacement
		SetDataFolder root:
			String SiteNum, Hole
			WAVE/T H, TW, DirW
			WAVE Leg,Site,Cor,Sc,Top_cm_,Bot_cm_,Depth__mbsf_,Velocity__m_s_
			If( !WaveExists( Velocity__m_s_ ) )
				Print "I can't find the datawave \"Velocity__m_s_\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are PWS data from JANUS?"
				ABORT "I can't find the datawave \"Velocity__m_s_\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are PWS data from JANUS?"
			EndIf
			If( NumType( Cor[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1, Leg,Site,H,Cor,TW,Sc,Top_cm_,Bot_cm_,Depth__mbsf_,DirW,Velocity__m_s_
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "Velocity__m_s_", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Hole = "U" + Num2Str( Site[ 0 ] ) + H[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_PWS"
			Replace_NaNswithNumber_F( "Sc", CC_Replacement )
			Duplicate/O H, $":" + SiteNum + "_PWS:" + Hole + "_PWS_Hole"; 
			Duplicate/O Cor, $":" + SiteNum + "_PWS:" + Hole + "_PWS_Core"; 
			Duplicate/O TW, $":" + SiteNum + "_PWS:" + Hole + "_PWS_Type"; 
			Duplicate/O Sc, $":" + SiteNum + "_PWS:" + Hole + "_PWS_Section"; 
			Duplicate/O Top_cm_, $":" + SiteNum + "_PWS:" + Hole + "_PWS_Interval"; 
			Duplicate/O Depth__mbsf_, $":" + SiteNum + "_PWS:" + Hole + "_PWS_mbsf"; 
			Duplicate/O DirW, $":" + SiteNum + "_PWS:" + Hole + "_PWS_Direction"; 
			Duplicate/O Velocity__m_s_, $":" + SiteNum + "_PWS:" + Hole + "_PWS_Vp"
			Duplicate/O H, $":" + SiteNum + "_PWS:" + Hole + "_PWS_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_PWS:" + Hole + "_PWS_Site"
			SiteWv = SiteNum
			EmptyJANUSDataTable( )
			KillWaves H, TW, DirW
			KillWaves Leg,Site,Cor,Sc,Top_cm_,Bot_cm_,Depth__mbsf_,Velocity__m_s_
	End
			