﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	
	Function NGRBatchLoad()
		SetDataFolder root:
			KillPath/Z Data_Path
			KillVariables/Z Hole
			String DataFileList
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement, i
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is usual )" 
			DoPrompt "NGRBatchLoad", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			DoAlert 0, "Select the data folder.\r\rThis function will attempt to process all \".csv\" files in the selected folder. You will generate an error if there are non-NGR files."
			NewPath Data_Path
			DataFileList = IndexedFile( Data_Path, -1, ".csv" )
			For( i = 0; i < ItemsInList( DataFileList ); i += 1 )
				LoadWave/A/P=Data_Path/Q/J/W/K=0/L={0,1,0,0,0}/v={",","\"",0,0} StringFromList( i, DataFileList )				
				WAVE/T Site,Hole,Type,Timestamp__UTC_,Text_ID,Test_No_,Comments
	  			WAVE ExpW,Core,Sect,Offset__cm_,Depth_CSF_A__m_,Depth_CSF_B__m_,NGR_total_counts__cps_,Error__cps_,Relative_Error,Instrument
				If( StrSearch( Site[ 0 ], "\"", 0 ) > -1 ) // This section takes care of the quotes in the downloaded data file if they are present
					String S2 = Site[0]; S2 = S2[ 1 , StrLen( S2 ) - 2 ]; Site = S2
					String H2 = Hole[0]; H2 = H2[ 1 , StrLen( H2 ) - 2 ]; Hole = H2
					String T2 = Type[0]; T2 = T2[ 1 , StrLen( T2 ) - 2 ]; Type = T2
				EndIf
				String H = Site[0] + Hole[0], SiteNum = RemoveEnding( H )
				Replace_NaNswithNumber_F( "Sect", CC_Replacement )
				NewDataFolder/O $SiteNum + "_NGR"
				Duplicate/O Site, $":" + SiteNum + "_NGR:" + H + "_NGR_Site"; 
				Duplicate/O Hole, $":" + SiteNum + "_NGR:" + H + "_NGR_Hole"; 
				Duplicate/O Core, $":" + SiteNum + "_NGR:" + H + "_NGR_Core"; 
				Duplicate/O Type, $":" + SiteNum + "_NGR:" + H + "_NGR_Type"; 
				Duplicate/O Sect, $":" + SiteNum + "_NGR:" + H + "_NGR_Section"; 
				Duplicate/O Offset__cm_, $":" + SiteNum + "_NGR:" + H + "_NGR_Interval"; 
				Duplicate/O Depth_CSF_A__m_, $":" + SiteNum + "_NGR:" + H + "_NGR_CSFA"; 
				Duplicate/O NGR_total_counts__cps_, $":" + SiteNum + "_NGR:" + H + "_NGR_NGR"
				KillWaves Site,Hole,Type,Timestamp__UTC_,Text_ID,Test_No_,Comments
	  			KillWaves ExpW,Core,Sect,Offset__cm_,Depth_CSF_A__m_,Depth_CSF_B__m_,NGR_total_counts__cps_,Error__cps_,Relative_Error,Instrument
			EndFor
	End
			


//	Function NGRLOREDataLoader( )
		SetDataFolder root:
			String/G G_H
			String H = G_H, SiteNum
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt H, "Hole ( e.g. U1242A )"
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "NGRLOREDataLoader", H, CC_Replacement
			G_H = H; G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "NGRLOREDataLoader_F( \"" + H + "\",", CC_Replacement, ")"
			NGRLOREDataLoader_F( H, CC_Replacement )
	End
	
//	Function NGRLOREDataLoader_F( H, CC_Replacement )
			String H
			Variable CC_Replacement
			H = UpperStr( H )
			CheckHole4aU( H )
		SetDataFolder root:
			String SiteNum
			SiteNum = RemoveEnding( H )
			WAVE/T Site,Hole,Type,Timestamp__UTC_,Text_ID,Test_No_,Comments
  			WAVE ExpW,Core,Sect,Offset__cm_,Depth_CSF_A__m_,Depth_CSF_B__m_,NGR_total_counts__cps_,Error__cps_,Relative_Error,Instrument
			If( !WaveExists( NGR_total_counts__cps_ ) )
				Print "I can't find the datawave \"NGR_total_counts__cps_\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are NGR data from LORE?"
				ABORT "I can't find the datawave \"NGR_total_counts__cps_\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are NGR data from LORE?"
			EndIf
			If( NumType( Core[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1, Site,Hole,Type,Timestamp__UTC_,Text_ID,Test_No_,Comments
				DeletePoints 0,1, ExpW,Core,Sect,Offset__cm_,Depth_CSF_A__m_,Depth_CSF_B__m_,NGR_total_counts__cps_,Error__cps_,Relative_Error,Instrument
			EndIf
			If( !StringMatch( Hole[1], H[ StrLen( H ) - 1 ] ) ) // Checks to see that the data table has data from the designated Hole
				Print "The Hole in the data column is not the same as the Hole input.\r\t\t" + Site[1] + Hole[1] + " vs " + H 
				ABORT "The Hole in the data column is not the same as the Hole input.\r\r" + Site[1] + Hole[1] + " vs " + H 
			EndIf
			If( !StringMatch( Site[1], SiteNum ) )  // Checks to see that the data table has data from the designated Hole
				Print "The Site Number in the data column \"Site\" is not the same as the Site Number input.\r\t\t" + Site[1] + " vs " + SiteNum
				ABORT "The Site Number in the data column \"Site\" is not the same as the Site Number input.\r\r" + Site[1] + " vs " + SiteNum
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "LOREDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:LOREDataTable" ), "NGR_total_counts__cps_", 0 ) < 0 ) // Checks that the data are in the designated Table named "LOREDataTable"
				Print "The data are not in a table named \"LOREDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyLOREDataTable()\r\t\tfrom the LORE_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"LOREDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyLOREDataTable\"\r\rfrom the LORE_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Replace_NaNswithNumber_F( "Sect", CC_Replacement )
			Rename Site, $H + "_NGR_Site"; 
			Rename Hole, $H + "_NGR_Hole"; 
			Rename Core, $H + "_NGR_Core"; 
			Rename Type, $H + "_NGR_Type"; 
			Rename Sect, $H + "_NGR_Section"; 
			Rename Offset__cm_, $H + "_NGR_Interval"; 
			Rename Depth_CSF_A__m_, $H + "_NGR_CSFA"; 
			Rename NGR_total_counts__cps_, $H + "_NGR_NGR"; 
			EmptyLOREDataTable( )
			KillWaves   ExpW,Depth_CSF_B__m_,Error__cps_,Relative_Error,Timestamp__UTC_,Instrument,Text_ID,Test_No_,Comments
			NewDataFolder/O $SiteNum + "_NGR"
	End
			