﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function MakeSpliceColorWave( )
		SetDataFolder root:
			String/G G_Hole, G_Technique, G_WvName, G_WvColor, G_Data
			String Site, Hole = G_Hole, Technique = G_Technique, Data = G_Data, WvList, WvName = G_WvName, WvColor = G_WvColor
			Variable i
			Prompt Hole, "Hole"
			Prompt Technique, "Technique"
			Prompt Data, "Data"
			DoPrompt "MakeSpliceColorWave", Hole, Technique, Data
			G_Hole = Hole; G_Technique = Technique
			AbortOnValue V_Flag, 0
			Site = RemoveEnding( Hole )
			DFREF DataFldr = $"root:" + Site + "_" + Technique
		SetDataFolder DataFldr
			WvList = WaveList( Hole + "*" + Technique + "_" + Data, ";", "" )
			Prompt WvName, "Select a Data Wave", popup, WvList
			String ColorList = "Black;Light Blue;Blue;Dark Blue;Light Green;Green;Dark Green;Yellow;Gold;Red;Dark Red;Orange;Brown;Violet;Purple"
			Prompt WvColor, "Select a color for the wave", popup, ColorList
			DoPrompt "MakeSpliceColorWave", WvName, WvColor
			G_WvName = WvName; G_WvColor = WvColor
			AbortOnValue V_Flag, 0
		SetDataFolder root:
			Print "MakeSpliceColorWave_F( \"" + WvName + "\", \"" + WvColor + "\" )"
			MakeSpliceColorWave_F( WvName, WvColor )
	End

	Function MakeSpliceColorWave_F( WvName, WvColor )
			String WvName, WvColor
			NewDataFolder/O Xtras
		SetDataFolder root:
			String Hole = DataWaveHole( WvName ), Technique = DataWaveTechnique( WvName )
			String Site = RemoveEnding( Hole ), WvList
			Variable i
			DFREF DataFldr = $"root:" + Site + "_" + Technique
		NewDataFolder/O/S $"root:Xtras:ColorWaves"
			ColorTab2Wave dBZ14
			WAVE M_Colors
		SetDataFolder DataFldr
			String ColorWaveName = "root:Xtras:ColorWaves:" + Site + "S_" + Technique + "_ColorWave"
			Make/O/N = ( NumPnts( $Site + "S_" + Technique + "_Core" ), 3 ) $ColorWaveName
			WAVE ColorWv = $ColorWaveName
			If( !Exists( Site + "S_" + Technique + "_Hole" ) )
				ABORT "Can't find " + Site + "S_" + Technique + "_Hole. This function uses the \"S\" convention for spliced data exclusively. If the data are in the \"_Splice\" form, use \"Batch_Rename_Waves\" to convert them."
			EndIf			
			WAVE/T HoleWv = $Site + "S_" + Technique + "_Hole"
			String HoleLetter = Hole[ StrLen( Hole ) - 1 ]
			WvList = WaveList( Hole + "*" + Technique, ";", "" )
			WAVE DataWv = $WvName
			String SpliceDataWaveName = Site + "S_" + Technique + "_" + DataWaveData( Wvname )
			StrSwitch( WvColor )
				Case "Black":
					ModifyGraph rgb($WvName)=( 0, 0, 0 )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	0 : ColorWv[ p ][0]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	0 : ColorWv[ p ][1]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	0 : ColorWv[ p ][2]
					Break
				Case "Light Blue":
					ModifyGraph rgb($WvName)=( M_Colors[0][0], M_Colors[0][1], M_Colors[0][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[0][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[0][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[0][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Blue":
					ModifyGraph rgb($WvName)=( M_Colors[1][0], M_Colors[1][1], M_Colors[1][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[1][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[1][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[1][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Dark Blue":
					ModifyGraph rgb($WvName)=( M_Colors[2][0], M_Colors[2][1], M_Colors[2][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[2][0] : ColorWv[ p ][0]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[2][1] : ColorWv[ p ][1]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[2][2] : ColorWv[ p ][2]
					Break
				Case "Light Green":
					ModifyGraph rgb($WvName)=( M_Colors[3][0], M_Colors[3][1], M_Colors[3][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[3][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[3][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[3][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Green":
					ModifyGraph rgb($WvName)=( M_Colors[4][0], M_Colors[4][1], M_Colors[4][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[4][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[4][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[4][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Dark Green":
					ModifyGraph rgb($WvName)=( M_Colors[5][0], M_Colors[5][1], M_Colors[5][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[5][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[5][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[5][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Yellow":
					ModifyGraph rgb($WvName)=( M_Colors[6][0], M_Colors[6][1], M_Colors[6][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[6][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[6][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[6][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Gold":
					ModifyGraph rgb($WvName)=( M_Colors[7][0], M_Colors[7][1], M_Colors[7][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[7][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[7][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[7][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Orange":
					ModifyGraph rgb($WvName)=( M_Colors[8][0], M_Colors[8][1], M_Colors[8][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[8][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[8][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[8][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Red":
					ModifyGraph rgb($WvName)=( M_Colors[9][0], M_Colors[9][1], M_Colors[9][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[9][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[9][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[9][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Dark Red":
					ModifyGraph rgb($WvName)=( M_Colors[10][0], M_Colors[10][1], M_Colors[10][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[10][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[10][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[10][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Brown":
					ModifyGraph rgb($WvName)=( M_Colors[11][0], M_Colors[11][1], M_Colors[11][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[11][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[11][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[11][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Violet":
					ModifyGraph rgb($WvName)=( M_Colors[12][0], M_Colors[12][1], M_Colors[12][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[12][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[12][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[12][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Purple":
					ModifyGraph rgb($WvName)=( M_Colors[13][0], M_Colors[13][1], M_Colors[13][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[13][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[13][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[13][2] : ColorWv[ p ][ 2 ]
					Break
			EndSwitch
			If( StrSearch( TraceNameList( "", ";", 3 ), SpliceDataWaveName, 3 ) > -1 )
				ModifyGraph zColor($SpliceDataWaveName)={$ColorWaveName,*,*,directRGB,0}		
			Endif
		SetDataFolder root:	
	End		


//	Function MakeSpliceColorWave( )
		SetDataFolder root:
			String/G G_Hole, G_Technique, G_WvName, G_WvColor
			String Site, Hole = G_Hole, Technique = G_Technique, WvList, WvName = G_WvName, WvColor = G_WvColor
			Variable i
			Prompt Hole, "Hole"
			Prompt Technique, "Technique"
			DoPrompt "MakeSpliceColorWave", Hole, Technique
			G_Hole = Hole; G_Technique = Technique
			AbortOnValue V_Flag, 0
			Site = RemoveEnding( Hole )
			DFREF DataFldr = $"root:" + Site + "_" + Technique
		SetDataFolder DataFldr
			WvList = WaveList( Hole + "*" + Technique, ";", "" )
			Prompt WvName, "Select a Data Wave", popup, WvList
			String ColorList = "Black;Light Blue;Blue;Dark Blue;Light Green;Green;Dark Green;Yellow;Gold;Red;Dark Red;Orange;Brown;Violet;Purple"
			Prompt WvColor, "Select a color for the wave", popup, ColorList
			DoPrompt "MakeSpliceColorWave", WvName, WvColor
			G_WvName = WvName; G_WvColor = WvColor
			AbortOnValue V_Flag, 0
		SetDataFolder root:
			Print "MakeSpliceColorWave_F( \"" + Hole + "\", \"" + Technique + "\", \"" + WvName + "\", \"" + WvColor + "\" )"
			MakeSpliceColorWave_F( Hole, Technique, WvName, WvColor )
	End

//	Function MakeSpliceColorWave_F( Hole, Technique, WvName, WvColor )
			String Hole, Technique, WvName, WvColor
			NewDataFolder/O Xtras
		SetDataFolder root:
			String Site, WvList
			Variable i
			Site = RemoveEnding( Hole )
			DFREF DataFldr = $"root:" + Site + "_" + Technique
		NewDataFolder/O/S $"root:Xtras:ColorWaves"
			ColorTab2Wave dBZ14
			WAVE M_Colors
		SetDataFolder DataFldr
			String ColorWaveName = "root:Xtras:ColorWaves:" + Site + "S_" + Technique + "_ColorWave"
			Make/O/N = ( NumPnts( $Site + "S_" + Technique + "_Core" ), 3 ) $ColorWaveName
			WAVE ColorWv = $ColorWaveName
			If( !Exists( Site + "S_" + Technique + "_Hole" ) )
				ABORT "Can't find " + Site + "S_" + Technique + "_Hole. This function uses the \"S\" convention for spliced data exclusively. If the data are in the \"_Splice\" form, use \"Batch_Rename_Waves\" to convert them."
			EndIf			
			WAVE/T HoleWv = $Site + "S_" + Technique + "_Hole"
			String HoleLetter = Hole[ StrLen( Hole ) - 1 ]
			WvList = WaveList( Hole + "*" + Technique, ";", "" )
			WAVE DataWv = $WvName
			String SpliceDataWaveName = Site + "S_" + Technique + "_" + DataWaveData( Wvname )
			StrSwitch( WvColor )
				Case "Black":
					ModifyGraph rgb($WvName)=( 0, 0, 0 )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	0 : ColorWv[ p ][0]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	0 : ColorWv[ p ][1]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	0 : ColorWv[ p ][2]
					Break
				Case "Light Blue":
					ModifyGraph rgb($WvName)=( M_Colors[0][0], M_Colors[0][1], M_Colors[0][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[0][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[0][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[0][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Blue":
					ModifyGraph rgb($WvName)=( M_Colors[1][0], M_Colors[1][1], M_Colors[1][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[1][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[1][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[1][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Dark Blue":
					ModifyGraph rgb($WvName)=( M_Colors[2][0], M_Colors[2][1], M_Colors[2][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[2][0] : ColorWv[ p ][0]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[2][1] : ColorWv[ p ][1]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[2][2] : ColorWv[ p ][2]
					Break
				Case "Light Green":
					ModifyGraph rgb($WvName)=( M_Colors[3][0], M_Colors[3][1], M_Colors[3][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[3][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[3][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[3][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Green":
					ModifyGraph rgb($WvName)=( M_Colors[4][0], M_Colors[4][1], M_Colors[4][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[4][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[4][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[4][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Dark Green":
					ModifyGraph rgb($WvName)=( M_Colors[5][0], M_Colors[5][1], M_Colors[5][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[5][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[5][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[5][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Yellow":
					ModifyGraph rgb($WvName)=( M_Colors[6][0], M_Colors[6][1], M_Colors[6][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[6][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[6][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[6][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Gold":
					ModifyGraph rgb($WvName)=( M_Colors[7][0], M_Colors[7][1], M_Colors[7][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[7][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[7][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[7][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Orange":
					ModifyGraph rgb($WvName)=( M_Colors[8][0], M_Colors[8][1], M_Colors[8][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[8][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[8][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[8][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Red":
					ModifyGraph rgb($WvName)=( M_Colors[9][0], M_Colors[9][1], M_Colors[9][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[9][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[9][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[9][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Dark Red":
					ModifyGraph rgb($WvName)=( M_Colors[10][0], M_Colors[10][1], M_Colors[10][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[10][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[10][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[10][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Brown":
					ModifyGraph rgb($WvName)=( M_Colors[11][0], M_Colors[11][1], M_Colors[11][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[11][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[11][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[11][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Violet":
					ModifyGraph rgb($WvName)=( M_Colors[12][0], M_Colors[12][1], M_Colors[12][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[12][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[12][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[12][2] : ColorWv[ p ][ 2 ]
					Break
				Case "Purple":
					ModifyGraph rgb($WvName)=( M_Colors[13][0], M_Colors[13][1], M_Colors[13][2] )
					ColorWv[ ][ 0 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[13][0] : ColorWv[ p ][ 0 ]
					ColorWv[ ][ 1 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[13][1] : ColorWv[ p ][ 1 ]
					ColorWv[ ][ 2 ] = StringMatch( HoleLetter, HoleWv[p] ) ?	M_Colors[13][2] : ColorWv[ p ][ 2 ]
					Break
			EndSwitch
			If( StrSearch( TraceNameList( "", ";", 3 ), SpliceDataWaveName, 3 ) > -1 )
				ModifyGraph zColor($SpliceDataWaveName)={$ColorWaveName,*,*,directRGB,0}		
			Endif
		SetDataFolder root:	
	End		

