﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function MarkDisturbance()
		SetDataFolder root:
			Variable i, ListPoints
			String/G G_ImageFolder, G_ImageName, G_MaskNote
			String ImageList, ImageFolder = G_ImageFolder, Site, Hole, Size, ImageName = G_ImageName, MaskNote = G_MaskNote
			DoAlert/T = "mbsf Check" 1, "This function will revert core images to CSF/mbsf.\r\rDo you want to continue?"
			AbortOnValue V_Flag == 2, 0
			Prompt ImageFolder, "Select Core Image Folder", popup, SortList( FolderList( "*" ) )
			DoPrompt "MarkDisturbance", ImageFolder 
			G_ImageFolder = ImageFolder
			AbortOnValue V_Flag, 0
			Hole = FirstPart( ImageFolder )
			Site = RemoveEnding( Hole )
		NewDataFolder/O/S $Site + "_Disturbance"	
			WAVE TopDepth = $Hole + "_Disturbance_TopDepth"
			If( !WaveExists( TopDepth ) )
				Make/O/N = 0 $Hole + "_Disturbance_TopDepth", $Hole + "_Disturbance_BottomDepth"
				Make/O/T/N = 0 $Hole + "_Disturbance_CoreImage"
				Make/O/T/N = 0 $Hole + "_Disturbance_Note"
			EndIf
			WAVE TopDepth = $Hole + "_Disturbance_TopDepth", BottomDepth = $Hole + "_Disturbance_BottomDepth"
			WAVE/T CoreImage = $Hole + "_Disturbance_CoreImage"
			WAVE/T CoreNote = $Hole + "_Disturbance_Note"
		SetDataFolder root:
			If( ItemsInList( WinList( "MaskTable", ";", "VISIBLE:1" ) ) == 0 )
				Edit/K=0/W=(573,706,1252,906)/N = MaskTable CoreImage, TopDepth, BottomDepth, CoreNote
				ModifyTable alignment=1,width=150,  Width(Point)= 50
			EndIf
			Hole = FirstPart( ImageFolder ), Size = SecondPart( ImageFolder )
			Image_CCSF_2_CSF_F( Hole, Size )
			KillWindow/Z CorePlot
			If( ItemsInList( WinList( "CorePlot", ";", "VISIBLE:1" ) ) == 0 )
				Display /W=(542,47,2185,484)/N = CorePlot;DelayUpdate
				ShowInfo
				Cursor/A=1/H=2/T=3/M/S=1/C=(65535,0,0) A
				Cursor/A=1/H=2/T=3/M/S=1/C=(65535,0,0) B
			EndIf
		SetDataFolder $ImageFolder
			ImageList = SortList( WaveList( "*", ";", "DIMS:3" ) )
			Try
				Prompt ImageName, "Select an Image:", popup, ImageList
				DoPrompt "MarkDisturbance", ImageName
				G_ImageName = ImageName
				AbortOnValue V_Flag, 0
			Catch
				SetDataFolder root:
			EndTry
			WAVE Image = $ImageName
			AppendImage Image
			Cursor/I/P A $NameOfWave( Image ) 100, 100
			Cursor/I/P B $NameOfWave( Image ) 100, 150
			Do  // This do loop runs forever or until the function is stopped by the user
				DoUpdate;
				PauseForCursor()
				If( PCsr(A) != 100 || PCsr(B) != 100 ) // Cursors were moved
					InsertPoints 0,1, TopDepth, BottomDepth, CoreImage, CoreNote
					CoreImage[ 0 ] = NameOfWave( Image )
					TopDepth[ 0 ] = XCsr(A)
					BottomDepth[ 0 ] = XCsr(B)
					Try
						Prompt MaskNote, "Note:"
						DoPrompt "MarkDisturbance", MaskNote
						G_MaskNote = MaskNote
						AbortOnValue V_Flag, 0				
						CoreNote[ 0 ] = MaskNote
					Catch
						SetDataFolder root:
					EndTry
				EndIf
				DoUpdate;
				DoAlert/T = "Next Core?" 2, "Next core?\r\r    \"No\" to continue with this core.\r\r    Select \"Cancel\" to exit function"
				Switch( V_Flag )
					Case 2:
						Continue
					Case 1:
						RemoveImage $NameOfWave( Image )
						i += 1
						If( i == ItemsInList( ImageList ) )
							KillWindow CorePlot
							Sort TopDepth, CoreImage,TopDepth,BottomDepth
						SetDataFolder root:
							ABORT "Finished with Images in " + ImageFolder
						EndIf
						DoPrompt "MarkDisturbance", ImageName
						AbortOnValue V_Flag, 0
						WAVE Image = $ImageName
						AppendImage Image			
						Cursor/I/P A $NameOfWave( Image ) 100, 100
						Cursor/I/P B $NameOfWave( Image ) 100, 150
						Break
					Case 3:
						KillWindow CorePlot
						Sort TopDepth, CoreImage,TopDepth,BottomDepth
					SetDataFolder root:
						ABORT
				EndSwitch			
			While(1)
	End
	
#Include "PauseForCursor"

