﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


//	Function CaCO3NGDCDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "CaCO3NGDCDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "CaCO3NGDCDataLoader_F(",CC_Replacement,")"
			CaCO3NGDCDataLoader_F( CC_Replacement )
	End
	
//	Function CaCO3NGDCDataLoader_F( CC_Replacement )
			Variable CC_Replacement
		SetDataFolder root:
			Variable/G G_HoleVorS
			String SiteNum, H
			EXECUTE "G_HoleVorS = WaveType( Hole )" // This necessary for DSDP data as the first Hole was "blank" and the second Hole is "A".
			If( G_HoleVorS == 2 || G_HoleVorS == 4 )									// The Hole wave is read as a numerical wave and must be replaced with a text wave with value "X"
				DoWindow/F NGDCDataTable
				EXECUTE "RemoveFromTable Hole"
				EXECUTE "KillWaves Hole "
				EXECUTE "Make/T/N = ( NumPnts( Site ) ) Hole"
				EXECUTE "Hole = \"X\""
				EXECUTE "AppendToTable Hole"
			Endif
			WAVE/T method_code,data_source_code,Hole
  			WAVE leg,site,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_,top_of_core_depth__m_,sample_depth__m_
  			WAVE percent_total_carbon,percent_organic_carbon,percent_calcium_carbonate__CaCO3_
  			If( !WaveExists( percent_calcium_carbonate__CaCO3_ ) )
				Print "I can't find the datawave \"percent_calcium_carbonate__CaCO\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are CaCO3 data from NGDC?"
				ABORT "I can't find the datawave \"percent_calcium_carbonate__CaCO\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are CaCO3 data from NGDC?"
			EndIf
			If( NumType( Core[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1, method_code,data_source_code,Hole
				DeletePoints 0,1, leg,site,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_,top_of_core_depth__m_,sample_depth__m_
				DeletePoints 0,1, percent_total_carbon,percent_organic_carbon,percent_calcium_carbonate__CaCO3_			
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "NGDCDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:NGDCDataTable" ), "percent_calcium_carbonate__CaCO", 0 ) < 0 ) // Checks that the data are in the designated Table named "NGDCDataTable"
				Print "The data are not in a table named \"NGDCDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyNGDCDataTable()\r\t\tfrom the NGDC_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"NGDCDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyNGDCDataTable\"\r\rfrom the NGDC_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			H = "U" + Num2Str( Site[ 0 ] ) + Hole[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_CaCO3"
			Replace_NaNswithNumber_F( "Section", CC_Replacement )
			Duplicate/O Hole, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_Hole"; 
			Duplicate/O Core, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_Core"; 
			Duplicate/O Section, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_Section"; 
			Duplicate/O top_interval_depth__cm_, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_Interval"; 
			Duplicate/O sample_depth__m_, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_mbsf"; 
			Duplicate/O root:percent_total_carbon, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_TotalC"; 
			Duplicate/O percent_calcium_carbonate__CaCO3_, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_CaCO3"
			Duplicate/O percent_organic_carbon, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_OrgC"
			Duplicate/O Hole, $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_CaCO3:" + H + "_CaCO3_Site"
			SiteWv = SiteNum
			EmptyNGDCDataTable( )
			KillWaves method_code,data_source_code,Hole
  			KillWaves leg,site,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_,top_of_core_depth__m_,sample_depth__m_
  			KillWaves percent_total_carbon,percent_organic_carbon,percent_calcium_carbonate__CaCO3_
	End
			