﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function MADNGDCDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "MADNGDCDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "MADNGDCDataLoader_F(",CC_Replacement,")"
			MADNGDCDataLoader_F( CC_Replacement )
	End

	Function MADNGDCDataLoader_F( CC_Replacement )
			Variable CC_Replacement
		SetDataFolder root:
			Variable/G G_HoleVorS
			String SiteNum, H
			EXECUTE "G_HoleVorS = WaveType( Hole )" // This necessary for DSDP data as the first Hole was "blank" and the second Hole is "A".
			If( G_HoleVorS == 2 || G_HoleVorS == 4 )									// The Hole wave is read as a numerical wave and must be replaced with a text wave with value "X"
				DoWindow/F NGDCDataTable
				EXECUTE "RemoveFromTable Hole"
				EXECUTE "KillWaves Hole "
				EXECUTE "Make/T/N = ( NumPnts( Site ) ) Hole"
				EXECUTE "Hole = \"X\""
				EXECUTE "AppendToTable Hole"
			Endif
			WAVE/T Hole
  			WAVE leg,site,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_,top_of_core_depth__m_
  			WAVE sample_depth__m_,wet_water_content__no_units_,porosity,wet_bulk_density__g_cc_,grain_density__g_cc_
			WAVE salt_correction_leg_96____or_bl  			
			If( !WaveExists( wet_bulk_density__g_cc_ ) )
				Print "I can't find the datawave \"wet_bulk_density__g_cc_\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are MAD data from NGDC?"
				ABORT "I can't find the datawave \"wet_bulk_density__g_cc_\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are MAD data from NGDC?"
			EndIf
			If( NumType( Core[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1, leg,site,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_,top_of_core_depth__m_
  				DeletePoints 0,1, sample_depth__m_,wet_water_content__no_units_,porosity,wet_bulk_density__g_cc_,grain_density__g_cc_
				DeletePoints 0,1, salt_correction_leg_96____or_bl  			
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "NGDCDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:NGDCDataTable" ), "wet_bulk_density__g_cc_", 0 ) < 0 ) // Checks that the data are in the designated Table named "NGDCDataTable"
				Print "The data are not in a table named \"NGDCDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyNGDCDataTable()\r\t\tfrom the NGDC_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"NGDCDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyNGDCDataTable\"\r\rfrom the NGDC_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			H = "U" + Num2Str( Site[ 0 ] ) + Hole[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_MAD"
			Replace_NaNswithNumber_F( "Section", CC_Replacement )
			Duplicate/O Hole, $":" + SiteNum + "_MAD:" + H + "_MAD_Hole"; 
			Duplicate/O Core, $":" + SiteNum + "_MAD:" + H + "_MAD_Core"; 
			Duplicate/O Section, $":" + SiteNum + "_MAD:" + H + "_MAD_Section"; 
			Duplicate/O top_interval_depth__cm_, $":" + SiteNum + "_MAD:" + H + "_MAD_Interval"; 
			Duplicate/O sample_depth__m_, $":" + SiteNum + "_MAD:" + H + "_MAD_mbsf"; 
			Duplicate/O wet_bulk_density__g_cc_, $":" + SiteNum + "_MAD:" + H + "_MAD_RhoB"; 
			Duplicate/O grain_density__g_cc_, $":" + SiteNum + "_MAD:" + H + "_MAD_RhoG"
			Duplicate/O wet_water_content__no_units_, $":" + SiteNum + "_MAD:" + H + "_MAD_WC"
			Duplicate/O porosity, $":" + SiteNum + "_MAD:" + H + "_MAD_Phi"
			Duplicate/O Hole, $":" + SiteNum + "_MAD:" + H + "_MAD_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_MAD:" + H + "_MAD_Site"
			SiteWv = SiteNum
			EmptyNGDCDataTable( )
  			KillWaves Hole, leg,site,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_,top_of_core_depth__m_
  			KillWaves sample_depth__m_,wet_water_content__no_units_,porosity,wet_bulk_density__g_cc_,grain_density__g_cc_
			KillWaves salt_correction_leg_96____or_bl  			

	End
			