﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function ProcessOffsets()
		SetDataFolder root:
			String/G G_DataTypes, G_HoleList, G_DepthTypeIn, G_DepthTypeOut
			String DataTypes = G_DataTypes, HoleList = G_HoleList, Data, DepthTypeIn = G_DepthTypeIn, DepthTypeOut = G_DepthTypeOut
			Variable i
			Prompt DataTypes, "List Technique Types Separated by Semicolons. No blanks. Use \"S2\" for images."
			Prompt HoleList, "List Holes Separated by Semicolons. No blanks.:"
			Prompt DepthTypeIn, "Input Depth Data Type (e.g. CSF, CSFA, mbsf, etc):"
			Prompt DepthTypeOut, "Output Depth Data Type (e.g. CCSF, CCSFA, mcd, rmcd, etc):"
			DoPrompt "ProcessOffsets", HoleList, DataTypes, DepthTypeIn, DepthTypeOut
			G_DataTypes = DataTypes; G_HoleList = HoleList; G_DepthTypeIn = DepthTypeIn; G_DepthTypeOut = DepthTypeOut
			AbortOnValue V_Flag, 0
			ProcessOffsets_F( HoleList, DataTypes, DepthTypeIn, DepthTypeOut )
			Print "ProcessOffsets_F( \"" + HoleList + "\", \"" + DataTypes + "\", \"" + DepthTypeIn + "\", \"" + DepthTypeOut + "\" )"
	End

	Function ProcessOffsets_F( HoleList, DataTypes, DepthTypeIn, DepthTypeOut )
			String DataTypes, HoleList, DepthTypeIn, DepthTypeOut
		SetDataFolder root:
			String Data, Hole, Site
			Variable i, j
			CheckList4Semicolons( DataTypes )
			CheckList4Semicolons( HoleList )
			For( j = 0; j < ItemsInList( HoleList ); j += 1 ) // The outer ( j ) loop works through all of the Holes requested
				Hole = StringFromList( j, HoleList )
				Site = RemoveEnding( Hole )
				If( Stringmatch( Hole, Site + "S" ) ) // This allows the function to skip Hole "S" - spliced data.
					Continue // The Continue command skips to the end of the instructions in the loop, but does not break out of the loop
				Endif
				Add_Offsets_2_Matrix_F( Hole ) // Updates coring matrix with offsets - includes checks for offset and matrix waves
				For( i = 0; i < ItemsInList( DataTypes ); i += 1 ) // Inner ( i ) loop works through all of the data types requested
					Data = StringFromList( i, DataTypes )
					If( StringMatch( Data, "S2" ) )
						Image_CSF_2_CCSF_F( Hole, Data ) // Applies offsets to images
					EndIf
					If( !StringMatch( Data, "S2" ) ) // Applies offsets to non-image data
						If( !Exists( "root:" + Site + "_" + Data + ":" + Hole + "_" + Data + "_" + DepthTypeIn ) )	// Checks to see if the CSF/mbsf wave is present.
							SetDataFolder root:
							Print "\rThere is no " + DepthTypeIn + " wave for Hole " + Hole + " in folder " + Site + "_" + Data + "\r"
							DoAlert 1, "There is no " + DepthTypeIn + " wave for Hole " + Hole + " in folder " + Site + "_" + Data + "\r\rDo you want to skip it and continue?"
							If( V_Flag == 2 ) // User chooses to stop after warning
								SetDataFolder root:
								ABORT //"There is no " + DepthTypeIn + " wave for Hole " + Hole + " in folder " + Site + "_" + Data
							Else
								Continue // Skips to the bottom of the i loop and contnues looping
							EndIf
						EndIf
						Calculate_CCSF_Wave_F( Hole, Data, DepthTypeIn, DepthTypeOut ) // Applies offsets to create/update CCSF/mcd wave
						Add_NaNs_F( Hole, Data ) // Adds blank lines between cores
						SetDataFolder root:
					EndIf
				EndFor	// End of i loop
			EndFor // End of j loop
	End

-----------------------------------------------------------------------------------------
