﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// This function checks to see that all waves for a given hole and technique have the same length. Otherwise splicing may be a problem.

	Function CheckEqualWaveLengthsHole( Hole, Technique )
		String Hole, Technique
		String HoleLst, WvList, Site = RemoveEnding( Hole )
		Variable i, j, DataPoints
		SetDataFolder $"root:" + Site + "_" + Technique
				WvList = WaveList( Hole + "*", ";", "" ) // Lists waves for a hole
				DataPoints = NumPnts( $StringFromList( 0, WvList ) ) // The number of data points in the first wave of the hole list
				For( j = 0; j < ItemsInList( WvList ); ++j )
					If( NumPnts( $StringFromList( j, WvList ) ) != DataPoints ) // Checks to be sure that all of the waves from a hole have the same number of points as the first wave in the list
						ABORT "The number of points in " + Technique + " data waves from Hole " + Hole + " are not all equal. This needs to be fixed or you may get incorrect results from some functions."
						Print "The number of points in " + Technique + " data waves from Hole " + Hole + " are not all equal. This needs to be fixed or you may get incorrect results from some functions."
					EndIf
				EndFor
		SetDataFolder root:	
	End		


// This function checks to see that all waves for each hole of a given site and technique have the same length. Otherwise splicing may be a problem.
	Function CheckEqualWaveLengthsSite( Site, Technique )
		String Site, Technique
		String HoleLst, WvList, Hole
		Variable i, j, DataPoints
		SetDataFolder $"root:" + Site + "_" + Technique
			HoleLst = HoleList()		// HoleList is a user function that creates a list of the holes in the specified data folder.
			For( i = 0; i < ItemsInList( HoleLst ); i += 1 ) // Cycles through each hole.
				Hole = StringFromList( i, HoleLst )
				WvList = WaveList( Hole + "*", ";", "" ) // Lists waves for a hole
				DataPoints = NumPnts( $StringFromList( 0, WvList ) ) // The number of data points in the first wave of the hole list
				For( j = 0; j < ItemsInList( WvList ); ++j )
					If( NumPnts( $StringFromList( j, WvList ) ) != DataPoints ) // Checks to be sure that all of the waves from a hole have the same number of points as the first wave in the list
						ABORT "The number of points in " + Technique + " data waves from Hole " + Hole + " are not all equal. This needs to be fixed or you may get incorrect results from some functions."
						Print "The number of points in " + Technique + " data waves from Hole " + Hole + " are not all equal. This needs to be fixed or you may get incorrect results from some functions."
					EndIf
				EndFor
			EndFor
		SetDataFolder root:	
	End		
	
	
	
