#pragma rtGlobals=1		// Use modern global access method.
	
	RGB_Split() splits a color image into three greyscale images representing the Red, Green,
	and Blue layers of the color composite. The resultant image waves have the same name as
	the original, with "R_", "G_", or "B_" added to the front. New images are placed in root:.
	
	Function RGB_Split( )
		SetDataFolder root:
			String ImageName, ImagePath, R_layer, G_layer, B_layer;
			String H_layer, S_layer, L_layer;
			Variable Colon
			DoAlert 1, "Did You Select the Core Image in the Data Browser?"
			If(V_Flag==2)
			Abort("Select Core Images and Run Again.")
			EndIf
			ImagePath = GetBrowserSelection(0)
			Colon = StrSearch(ImagePath,":",inf,1)
			ImageName = ImagePath[Colon+1,inf]
			WAVE Image = $ImagePath
			R_Layer = "R_" + ImageName;
			G_Layer = "G_" + ImageName;
			B_Layer = "B_" + ImageName;
			Make/O/B/U/N = ( dimsize( Image, 0 ), dimsize( Image, 1 ) ), $R_Layer, $G_Layer, $B_Layer;
			WAVE Red = $R_Layer, Green = $G_Layer, Blue = $B_Layer
			Red[][] = Image[p][q][0];
			Green[][] = Image[p][q][1];
			Blue[][] = Image[p][q][2];
			CopyScales Image Red, Green, Blue
			PauseUpdate
			Display; AppendImage/R Red
			SetAxis/A/R right 
			Display; AppendImage/R Green
			SetAxis/A/R right  
			Display; AppendImage/R Blue
			SetAxis/A/R right  
			ImageTransform RGB2HSL Image
			WAVE M_RGB2HSL
			H_Layer = "H_" + ImageName;
			S_Layer = "S_" + ImageName;
			L_Layer = "L_" + ImageName;
			Make/O/B/U/N = ( dimsize( M_RGB2HSL, 0 ), dimsize( M_RGB2HSL, 1 ) ), $H_Layer, $S_Layer, $L_Layer;
			WAVE HUE = $H_Layer, SAT = $S_Layer, LUM = $L_Layer
			HUE[][] = M_RGB2HSL[p][q][0];
			SAT[][] = M_RGB2HSL[p][q][1];
			LUM[][] = M_RGB2HSL[p][q][2];
			CopyScales M_RGB2HSL Hue, Sat, Lum
			Display; AppendImage/R Hue
			SetAxis/A/R right
			Display; AppendImage/R Sat
			SetAxis/A/R right
			Display; AppendImage/R Lum
			SetAxis/A/R right
	End
	
	
//	Function Image_Split( )
		SetDataFolder root:
			String ImageNameStr//, R_layer, G_layer, B_layer;
			ImageLoad/O/Q
			If( StrSearch( S_FileName, ".", 0 ) > 1 )
				ImageNameStr = "U" + S_FileName[ 0, StrSearch( S_FileName, ".", 0 ) - 1 ]
			EndIf
			If( StrSearch( ImageNameStr, "-", 0 ) > 1 )
				ImageNameStr = ImageNameStr[ 0, StrSearch( S_FileName, "-", 0 ) - 1 ]
			EndIf
			Duplicate/O $S_FileName $ImageNameStr
			KillWaves/Z $S_FileName
			WAVE Image = $ImageNameStr
			ImageRotate/O/W/A = 90 Image
			Make/O/B/U/N = ( dimsize( Image, 0 ), dimsize( Image, 1 ) ), Red, Green, Blue;
			Red[][] = Image[p][q][0];
			Green[][] = Image[p][q][1];
			Blue[][] = Image[p][q][2];
			CopyScales Image Red, Green, Blue
			NewImage/K=1 Red
	End
	
