﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function Select_Offsets()
		SetDataFolder root:
			String/G G_Site, G_Folder, G_YorN, G_YorN2
			String Site = G_Site, Folder = G_Folder, YorN = G_YorN, YorN2 = G_YorN2
			String OffsetsList = WaveList( "*Offsets", ";", "" ) // Create list of offset waves in root
			String ActiveOffsets = note( $StringFromList( 0, WaveList( "*Offsets", ";", "" ) )  ) // ActiveOffsets is the name of the offset folder that offset waves in root came from
			Variable i
			If( Strlen( ActiveOffsets ) > 0 ) // If there is no wavenote with a name of an offsets folder, or a name for a new offsets folder, there is a warning ( see Else )
				Prompt Site, "Site"
				Prompt YorN2, "Save the active offsets to offsets folder \"" + ActiveOffsets + "\"", popup, "Yes;No" // Does the user want to save the offsets to the folder they came from or a new folder named in the offsets wavenote
				DoPrompt "Select_Offsets", Site, YorN2
				G_Site = Site, G_YorN2 = YorN2
				AbortOnValue V_Flag, 0
				NewDataFolder/O $Site + "_Offsets_Folders" // The folder of folders is created if it doesn't already exist
				DFREF OffsetsFldrs = $Site + "_Offsets_Folders" // Reference for the folder of folders
				If( Stringmatch( YorN2, "Yes" ) )
					NewDataFolder/O OffsetsFldrs:$ActiveOffsets // Makes a new offsets folder if the name from the wavenote doesn't already exist
					DFREF ActiveOffsetsFldr = OffsetsFldrs:$ActiveOffsets // Reference to the folder where the active offsets will be copied
					For( i = 0; i < ItemsInList( OffsetsList ); i += 1 )
						WAVE OffsetWave = $StringFromList( i, OffsetsList )
						Duplicate/O OffsetWave ActiveOffsetsFldr:$NameOfWave( OffsetWave ) // The waves in the acive offsets folder are copied into the folder specified above 
					EndFor
				EndIf
			Else // This is the case where the waves in root don't have a wavenote
				String Alert1 = "The active offsets do not have a wavenote identifying their offsets folder.\r\r"
				String Alert3 = "They will not be saved.\r\r Do you want to continue?"
				DoAlert 1, Alert1 + Alert3 
				If( V_Flag == 2 ) // User decides to stop after warning that active offsets will be lost
					SetDataFolder root:
					ABORT "Use \"Folder_WaveNotes\" to add a new folder name for the active offsets." // Abort window has suggestion to add a wavenote to the offsets naming a folder where they can be saved
				Else // User decides to continue and not save copies of the active offsets
					Prompt Site, "Site"
					DoPrompt "Select_Offsets", Site
					G_Site = Site
					AbortOnValue V_Flag, 0			
					DFREF OffsetsFldrs = $Site + "_Offset_Folders" // Reference to the folder of folders
				Endif
			EndIf
		SetDataFolder OffsetsFldrs // The folder of folders
			Prompt Folder, "Offsets to load into root:", popup, SortList( FolderList( "*" ) )
			Prompt YorN, "Process Offsets?", popup, "Yes;No"
			DoPrompt "Select_Offsets", Folder, YorN // The user chooses a set of offsets and whether to process those offsets after they are copied to root
			G_Folder = Folder; G_YorN = YorN
			If( V_Flag == 1 )		
				SetDataFolder root:
				AbortOnValue V_Flag, 0
			EndIf
			DFREF OffsetFolder = $Folder // Reference to the folder with the offsets to be copied
		SetDataFolder OffsetFolder // The folder with the selected offsets
			OffsetsList = Wavelist("*Offsets*", ";", "" )
			For( i = 0; i < ItemsInList( OffsetsList ); i += 1 ) // This loop copies the waves in the offset folder into root
				WAVE OffsetWave = $StringFromList( i, OffsetsList )
				Note/K OffsetWave, Folder // As the waves are copied to root their wavenote is set to the name of the folder they come from
				Duplicate/O OffsetWave $"root:" + NameofWave( OffsetWave )
			EndFor
		SetDataFolder root:
		If( StringMatch( YorN, "Yes" ) ) // Calls ProcessOffsets() if so desired
			ProcessOffsets()
		EndIf
	End		