﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function Select_Splice_Ties()
		SetDataFolder root:
			String/G G_Site, G_Folder, G_YorN, G_YorN2
			String Site = G_Site, Folder = G_Folder, YorN = G_YorN, YorN2 = G_YorN2
			String Wvlist
			Variable i
			Prompt Site, "Site"
			DoPrompt "Select_Splice_Ties", Site
			G_Site = Site
			AbortOnValue V_Flag, 0
			NewDataFolder/O $Site + "_Splice_Ties_Folders"
			DFREF TieFolders = $Site + "_Splice_Ties_Folders" // Reference to folder of folders
			DFREF ActiveTieFolder = $Site + "_Splice_Ties" // Reference to active splice ties folder, e.g. U1146_Splice_Ties. Different sets of ties are copied into this folder for processing
		SetDataFolder ActiveTieFolder
			WAVE CCSF_Bottom
			String ActiveWaveNote = note( CCSF_Bottom ) // Copies the wavenote identifying the "home" of the waves in the active spice tie folder
			If( StrLen( ActiveWaveNote ) == 0 ) // Checks to be sure there is a wavenote naming a folder in which to save the active ties
				String Alert1 = "The active ties do not have a wavenote identifying their ties folder.\r\r" // Warning if not
				String Alert3 = "They will not be saved.\r\r Do you want to continue?"
				DoAlert 1, Alert1 + Alert3 
				If( V_Flag == 2 )
				SetDataFolder root:
					ABORT "Use \"Folder_WaveNotes\" to add a new folder name as a wavenote for the active ties." // Use chose to stop and alert window suggests what to do next
				EndIf
			EndIf
		SetDataFolder TieFolders // Go to the folder of folders
			Prompt Folder, "Choose Ties:", popup, FolderList( "*" )
			Prompt YorN, "Save active splice tie values in \"" + ActiveWaveNote + "\"?", popup, "Yes;No"
			Prompt YorN2, "Convert Ties to Intervals?", popup, "Yes;No"
			DoPrompt "Select_Splice_Ties", Folder, YorN, YorN2 // Select a set of ties and decide whether to save existing set and whether to convert ties to intervals
			G_Folder = Folder; G_YorN = YorN; G_YorN2 = YorN2
			If( V_Flag )
				SetDataFolder root:
				ABORT
			EndIf
		If( StringMatch( YorN, "Yes" ) ) // User decides to save active set of ties to folder designated in wavenote
		SetDataFolder ActiveTieFolder
			WvList = WaveList( "*", ";", "" )
			For( i = 0; i < ItemsInList( WvList ); i += 1 ) // Copies from active splice_ties folder to "save" folder
				WAVE TieWave = $StringFromList( i, WvList )
				NewDataFolder/O TieFolders:$note( TieWave )
				DFREF Dfldr = TieFolders:$note( TieWave )
				Duplicate/O TieWave Dfldr:$NameOfWave( TieWave )				
			EndFor
		EndIf
		SetDataFolder TieFolders:$Folder // Copies ties in "save" folder to actice splice ties folder
			WvList = WaveList( "*", ";", "" )
			For( i = 0; i < ItemsInList( WvList ); i += 1 )
				WAVE TieWave = $StringFromList( i, WvList )
				Note/K TieWave, Folder // As the waves are copies a wavenote is added naming the folder they come from
				Duplicate/O TieWave ActiveTieFolder:$NameOfWave( TieWave )
			EndFor
		SetDataFolder root:
			If( StringMatch( YorN2, "Yes" ) ) // Creates splice intervals from splice ties if desired
				Splice_Tie_Data_2_Intervals_F( Site )
			EndIf
	End