//Updated functions (04.07.2018)

	Function Shift_Offsets( )																	//This now runs the command line function for all cores below using input from the user. 
		SetDataFolder root:
			String S_Hole, S_Offsets, S_SingleAll, S_NoteInput
			Variable V_Core, V_Offset
			Variable/G G_Core
			String/G G_Hole
			PauseUpdate;
			S_Hole = G_Hole																			//Updates hole string to what was stored in the global hole string
			V_Core = G_Core																			//Updates core variable to what was stored in the global core variable		
			Prompt S_Hole, "Hole:"
			Prompt V_Core, "Core:"
			Prompt V_Offset, "Change in offset (please use a positive offset to increase the offset/move a core down and a negative offset to decrease the offset/move a core up):"
			Prompt S_SingleAll, "Please choose to apply the offset to only the indicated core (Single) or also to all cores below (AllBelow):", popup, "Single;AllBelow"
			DoPrompt "Shift Offsets", S_Hole, V_Core, V_Offset, S_SingleAll; AbortOnValue V_Flag, 0
			V_Offset = round(V_Offset*100)/100												//Rounds offset to nearest CM.
			G_Hole = S_Hole																			//Updates global hole variable to the input hole
			G_Core = V_Core																			//Updates global core variable to the input core			
			Prompt	S_NoteInput, "Please include any information you wish about where the offset was defined (e.g., offset applied, target core, depth where offset was set, data used):"			//currently not very elegant
			DoPrompt "Offset Note", S_NoteInput; AbortOnValue V_Flag, 0
			Shift_Offsets_F( S_Hole, V_Core , V_Offset , S_SingleAll, S_NoteInput )
			Print "Shift_Offsets_F(\""+ S_Hole + "\" ,", V_Core, ",", V_Offset, ", \"" + S_SingleAll + "\" , \"" + S_NoteInput + "\" )"
	End	

-------------------------------------------------------------
-------------------------------------------------------------

//Upper level functions that run through input from cursors on the upper graph for a single and all cores. 

	Function Shift_Offsets_B_2_A( )															//This now runs the command line function for all cores below using input from the upper graph. 
		SetDataFolder root:
			String S_Site, S_Hole, S_Technique, S_Offsets, S_Core, S_FolderList, S_Folder, S_Data, S_SingleAll="AllBelow", S_NoteInput
			Variable V1, V2, i, V_Core, V_Offset, SLen
			Variable/G G_V1, G_Core
			String/G G_S1, G_Hole
			PauseUpdate;
			If(!StrLen( CsrWave( B ) ) || !StrLen( CsrWave( A ) ) )
				Abort "Cursor(s) Not on Graph"
			EndIf		
			If( DimSize( CsrWaveRef( B ), 1 ) )
				S_Hole = ImageHole( CsrWave( B ) )
				V_Core = ImageCore( CsrWave( B ) )
			Else
				S_Hole = DataWaveHole( CsrWave( B ) )
				S_Site = RemoveEnding( S_Hole )
				S_Technique = DataWaveTechnique( CsrWave( B ) )
		SetDataFolder $S_Site + "_" + S_Technique
				Wave CoreWv = $S_Hole + "_" + S_Technique + "_" + "Core"
		SetDataFolder root:
				V_Core = CoreWv[ PCsr( B ) ]
			EndIf
			V_Offset = HCsr( A ) - HCsr( B )													//This currently makes the offset positive if it is increased and negative if it is decreased. 
			V_Offset = round(V_Offset*100)/100												//Rounds offset to nearest CM.
			G_Hole = S_Hole																			//Updates global hole variable to the input hole
			G_Core = V_Core																			//Updates global core variable to the input core			
			String HoleCsrB = S_Hole, DepthScale = "CCSF", CCInclude="Y", HoleCsrA					//Define the strings needed for CSI_From_Depth_SR
			Variable Depth																			//Define the variable needed for CSI_From_Depth_SR
			String CSI_CsrA, CSI_CsrB															//Define the output strings 
			Depth = HCsr( A )																		//Set Depth to obtain CSI for CrsA
			If( DimSize( CsrWaveRef( A ), 1 ) )											//Sets Hole for the A Csr to HoleCsrA
				HoleCsrA = ImageHole( CsrWave( A ) )
			Else
				HoleCsrA = DataWaveHole( CsrWave( A ) )
			EndIf
			CSI_CsrA = CSI_From_Depth_SR( HoleCsrA, DepthScale, Depth, CCInclude )		//Sets CSI_CsrA to the CSI + CSF
			Depth = HCsr( B )																		//Set Depth to obtain CSI for CrsA
			CSI_CsrB = CSI_From_Depth_SR( HoleCsrB, DepthScale, Depth, CCInclude )		//Sets CSI_CsrA to the CSI + CSF
			If( DimSize( CsrWaveRef( B ), 1 ) )
				S_NoteInput = "Applied offset of " + num2str(V_Offset) + " to " + S_Hole + "-" + num2str(V_Core) + " and below (set between " + CSI_CsrA + " and " + CSI_CsrB + " using " + FirstPart( CsrWave( A ) ) + " images)."
			Else
				S_NoteInput = "Applied offset of " + num2str(V_Offset) + " to " + S_Hole + "-" + num2str(V_Core) + " and below (set between " + CSI_CsrA + " and " + CSI_CsrB + " using " + DataWaveTechnique( CsrWave( A ) ) + "_" + DataWaveData( CsrWave( A ) ) + " data)."
			EndIf
			Shift_Offsets_F( S_Hole, V_Core , V_Offset , S_SingleAll, S_NoteInput )
			Print "Shift_Offsets_F(\""+ S_Hole + "\" ,", V_Core, ",", V_Offset, ", \"" + S_SingleAll + "\" , \"" + S_NoteInput + "\" )"
	End	

-------------------------------------------------------------
	
	Function Shift_Offsets_B_2_A_1Core( )													//This now runs the command line function for a single core using input from the upper graph. 
		SetDataFolder root:
			String S_Site, S_Hole, S_Technique, S_Offsets, S_Core, S_FolderList, S_Folder, S_Data, S_SingleAll="Single", S_NoteInput
			Variable V1, V2, i, V_Core, V_Offset, SLen
			Variable/G G_V1, G_Core
			String/G G_S1, G_Hole
			PauseUpdate;
			If(!StrLen( CsrWave( B ) ) || !StrLen( CsrWave( A ) ) )
				Abort "Cursor(s) Not on Graph"
			EndIf		
			If( DimSize( CsrWaveRef( B ), 1 ) )
				S_Hole = ImageHole( CsrWave( B ) )
				V_Core = ImageCore( CsrWave( B ) )
			Else
				S_Hole = DataWaveHole( CsrWave( B ) )
				S_Site = RemoveEnding( S_Hole )
				S_Technique = DataWaveTechnique( CsrWave( B ) )
		SetDataFolder $S_Site + "_" + S_Technique
				Wave CoreWv = $S_Hole + "_" + S_Technique + "_" + "Core"
		SetDataFolder root:
				V_Core = CoreWv[ PCsr( B ) ]
			EndIf
			V_Offset = HCsr( A ) - HCsr( B )													///This currently makes the offset positive if it is increased and negative if it is decreased. 
			V_Offset = round(V_Offset*100)/100												//Rounds offset to nearest CM.
			G_Hole = S_Hole																			//Updates global hole variable to the input hole
			G_Core = V_Core																			//Updates global core variable to the input core			
			String Hole = S_Hole, DepthScale = "CCSF", CCInclude="Y"					//Define the strings needed for CSI_From_Depth_SR
			Variable Depth																			//Define the variable needed for CSI_From_Depth_SR
			String CSI_CsrA, CSI_CsrB															//Define the output strings 
			Depth = HCsr( A )																		//Set Depth to obtain CSI for CrsA
			CSI_CsrA = CSI_From_Depth_SR( Hole, DepthScale, Depth, CCInclude )		//Sets CSI_CsrA to the CSI + CSF
			Depth = HCsr( B )				//Set Depth to obtain CSI for CrsA
			CSI_CsrB = CSI_From_Depth_SR( Hole, DepthScale, Depth, CCInclude )		//Sets CSI_CsrA to the CSI + CSF
			If( DimSize( CsrWaveRef( B ), 1 ) )
				S_NoteInput = "Applied offset of " + num2str(V_Offset) + " to " + S_Hole + "-" + num2str(V_Core) + " (set between " + CSI_CsrA + " and " + CSI_CsrB + " using " + FirstPart( CsrWave( A ) ) + " images)."
			Else
				S_NoteInput = "Applied offset of " + num2str(V_Offset) + " to " + S_Hole + "-" + num2str(V_Core) + " (set between " + CSI_CsrA + " and " + CSI_CsrB + " using " + DataWaveTechnique( CsrWave( A ) ) + "_" + DataWaveData( CsrWave( A ) ) + " data)."
			EndIf
			Shift_Offsets_F( S_Hole, V_Core , V_Offset , S_SingleAll, S_NoteInput )
			Print "Shift_Offsets_F(\""+ S_Hole + "\" ,", V_Core, ",", V_Offset, ", \"" + S_SingleAll + "\" , \"" + S_NoteInput + "\" )"
	End	
	
-------------------------------------------------------------
-------------------------------------------------------------

//Command line function to be called within multi-core, single-core or user input shift. It will also record a note to the Offset Note Wave to indicate where the offset was defined. 	
//This function will round the offset to the nearest CM.
	
	Function Shift_Offsets_F(S_Hole, V_Core , V_Offset , S_SingleAll, S_NoteInput)		//Command line version called in the functions above.
			String S_Hole, S_SingleAll, S_NoteInput
			Variable V_Core, V_Offset
		SetDataFolder root:
			String S_Offsets, S_OffsetsNote, S_OffsetHistory
			Variable/G G_V1, G_Core
			String/G G_S1, G_Hole
			G_Hole = S_Hole																					//Updates global hole variable to the input hole
			G_Core = V_Core																					//Updates global core variable to the input core
			PauseUpdate;
			S_Offsets = S_Hole + "_Offsets"
			S_OffsetsNote = "root:Xtras:Splicing:" + S_Hole + "_OffsetsNote"				//Indicates which wave is the Offsets Note wave - in the Xtras - splicing folder.
			WAVE Offsets = $S_Offsets
			WAVE/T OffsetsNote = $S_OffsetsNote
			Duplicate/O Offsets root:Xtras:Splicing:Offset_Undo
			NOTE/K root:Xtras:Splicing:Offset_Undo, S_Offsets
			V_Offset = round(V_Offset*100)/100														//Rounds offset to nearest CM.
			IF(WaveExists(OffsetsNote)==0)
				ABORT "The OffsetsNote wave does not exist for " + S_Hole + ". \r\rPlease run \"InitializeReviseSplice\" first and try again."			//Makes a "history matrix" where changes to the offset are recorded. 
			EndIf		
			strswitch(S_SingleAll)
				case "Single":
					Offsets[ V_Core ] += V_Offset														//Applies the offset to only the given core. Offsets here should be "+" for a core moved down (offset increased) and "-" for a core moved up (offset decreased). 
					OffsetsNote[ V_Core] = S_NoteInput + "; " + OffsetsNote[ V_Core] 		//Note could include information about where and in what data the offset had been defined  
					Print "Changed offset of only Core", S_Hole, V_Core, "by", V_Offset
				break
				case "AllBelow":
					Offsets[ V_Core, ] += V_Offset														//Applies the offset to the given core and all cores below. Offsets here should be "+" for a core moved down (offset increased) and "-" for a core moved up (offset decreased). 
					OffsetsNote[ V_Core] = S_NoteInput + "; " + OffsetsNote[ V_Core] 		//Note could include information about where and in what data the offset had been defined 
					Print "Changed offset of Cores", S_Hole, V_Core, "and below by", V_Offset
				break	
				default:
					Abort "Incorrect syntax:\rTo apply the offset to a single core, please use \"Single\".\rTo apply the offset to the designated core and all cores below, please use \"AllBelow\"."
				break	
			endswitch
			IF(WaveExists(root:Xtras:Splicing:History_Offset_Changes)==0)
				Make/o/N=(1,6)/T root:Xtras:Splicing:History_Offset_Changes	
				WAVE/T History =	 $"root:Xtras:Splicing:History_Offset_Changes"						//Makes a "history matrix" where changes to the offset are recorded. 
				SetDimLabel 1,0, 'Timestamp', History
				SetDimLabel 1,1, 'Hole', History
				SetDimLabel 1,2, 'Core', History
				SetDimLabel 1,3, 'Offset change', History
				SetDimLabel 1,4, 'Applied to', History
				SetDimLabel 1,5, 'OffsetNote', History
				Edit/N=History_Offset_Changes History.ld
			EndIf	
			WAVE/T History =	 $"root:Xtras:Splicing:History_Offset_Changes"		
			InsertPoints 0,1, History
			History[0][0] = date() +" " + time()
			History[0][1] = S_Hole
			History[0][2] = num2str(V_Core)
			History[0][3] = num2str(V_Offset)
			History[0][4] = S_SingleAll
			History[0][5] = S_NoteInput
	End	
	

//Command line function to be called within multi-core, single-core or user input shift. It will also record a note to the Offset Note Wave to indicate where the offset was defined. 	
//This function will round the offset to the nearest CM.
	
//	Function Shift_Offsets_F(S_Hole, V_Core , V_Offset , S_SingleAll, S_NoteInput)		//Command line version called in the functions above.
			String S_Hole, S_SingleAll, S_NoteInput
			Variable V_Core, V_Offset
		SetDataFolder root:
			String S_Offsets, S_OffsetsNote, S_OffsetHistory
			Variable/G G_V1, G_Core
			String/G G_S1, G_Hole
			G_Hole = S_Hole																					//Updates global hole variable to the input hole
			G_Core = V_Core																					//Updates global core variable to the input core
			PauseUpdate;
			S_Offsets = S_Hole + "_Offsets"
			S_OffsetsNote = "root:Xtras:Splicing:" + S_Hole + "_OffsetsNote"				//Indicates which wave is the Offsets Note wave - in the Xtras - splicing folder.
			WAVE Offsets = $S_Offsets
			WAVE/T OffsetsNote = $S_OffsetsNote
			Duplicate/O Offsets root:Xtras:Splicing:Offset_Undo
			NOTE/K root:Xtras:Splicing:Offset_Undo, S_Offsets
			V_Offset = round(V_Offset*100)/100														//Rounds offset to nearest CM.
			IF(WaveExists(OffsetsNote)==0)
				ABORT "The OffsetsNote wave does not exist for " + S_Hole + ". \r\rPlease run \"InitializeReviseSplice\" first and try again."			//Makes a "history matrix" where changes to the offset are recorded. 
			EndIf		
			strswitch(S_SingleAll)
				case "Single":
			//		Offsets[ V_Core ] += V_Offset														//Applies the offset to only the given core. Offsets here should be "+" for a core moved down (offset increased) and "-" for a core moved up (offset decreased). 
					OffsetsNote[ V_Core] = S_NoteInput + "; " + OffsetsNote[ V_Core] 		//Note could include information about where and in what data the offset had been defined  
					Print "Changed offset of only Core", S_Hole, V_Core, "by", V_Offset
				break
				case "AllBelow":
			//		Offsets[ V_Core, ] += V_Offset														//Applies the offset to the given core and all cores below. Offsets here should be "+" for a core moved down (offset increased) and "-" for a core moved up (offset decreased). 
					OffsetsNote[ V_Core] = S_NoteInput + "; " + OffsetsNote[ V_Core] 		//Note could include information about where and in what data the offset had been defined 
					Print "Changed offset of Cores", S_Hole, V_Core, "and below by", V_Offset
				break	
				default:
					Abort "Incorrect syntax:\rTo apply the offset to a single core, please use \"Single\".\rTo apply the offset to the designated core and all cores below, please use \"AllBelow\"."
				break	
			endswitch
			IF(WaveExists(root:Xtras:Splicing:History_Offset_Changes)==0)
				Make/o/N=(1,6)/T root:Xtras:Splicing:History_Offset_Changes					//Makes a "history matrix" where changes to the offset are recorded. 
				SetDimLabel 1,0, 'Timestamp', root:Xtras:Splicing:History_Offset_Changes
				SetDimLabel 1,1, 'Hole', root:Xtras:Splicing:History_Offset_Changes
				SetDimLabel 1,2, 'Core', root:Xtras:Splicing:History_Offset_Changes
				SetDimLabel 1,3, 'Offset change', root:Xtras:Splicing:History_Offset_Changes
				SetDimLabel 1,4, 'Applied to', root:Xtras:Splicing:History_Offset_Changes
				SetDimLabel 1,5, 'OffsetNote', root:Xtras:Splicing:History_Offset_Changes
				Edit/N=History_Offset_Changes root:Xtras:Splicing:History_Offset_Changes.ld
			EndIf		
			Make/O/N=(1,6)/T Offset_Change
			Offset_Change[][0] = date() +" " + time()
			Offset_Change[][1] = S_Hole
			Offset_Change[][2] = num2str(V_Core)
			Offset_Change[][3] = num2str(V_Offset)
			Offset_Change[][4] = S_SingleAll
			Offset_Change[][5] = S_NoteInput
			Concatenate/NP=0 {Offset_Change}, root:Xtras:Splicing:History_Offset_Changes
			
//			InsertPoints 0,1, :Xtras:Splicing:History_Offset_Changes
//			Concatenate/NP=0 {Offset_Change}, root:Xtras:Splicing:History_Offset_Changes
			
			SortColumns/R/KNDX={0} sortWaves={:Xtras:Splicing:History_Offset_Changes}
						
			KillWaves Offset_Change
	End	
	
	
	
-------------------------------------------------------------
-------------------------------------------------------------
	
	Function Undo_Shift()																	//updated on 04.07.2018
		SetDataFolder root:			
			NewDataFolder/O root:Xtras													//Makes "Xtras" folder if it is not there
			NewDataFolder/O root:Xtras:Splicing										//Makes "Xtras:Splicing" folder if it is not there
			WAVE Offset_Undo = $"root:Xtras:Splicing:Offset_Undo"
			WAVE Offsets = $Note( Offset_Undo )
			Offsets = Offset_Undo
	End	

	
		
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------


	Function/T CSI_From_Depth_SR( Hole, DepthScale, Depth, CCInclude )				//instead of printing to history, this should print the formatted return the stringvariable "CSIstring" (e.g., SR) - DOES NOT RETURN THE CCSF
			String Hole, DepthScale, CCInclude
			Variable Depth
		SetDataFolder root:
			String HoleLetter = Hole[ StrLen( Hole ) - 1 ]
			String/G G_Site, G_Hole, G_DepthScale, G_CCInclude
			Variable/G G_Depth,	 G_i, G_j, G_Interval, G_CSF, G_CCSF
			Variable i = 0, j = 1, Interval, CC
			Variable V1 = 0, MatrixLayer = 0, CSF, CCSF
			G_Hole = Hole; G_DepthScale = DepthScale; G_CCInclude = CCInclude
			Variable/G G_Depth = Depth
			If( Exists( Hole + "_Coring_Matrix" ) )
				WAVE CMatrix = $Hole + "_Coring_Matrix"
			Else
				Abort Hole + "_Coring_Matrix \ris not in the root: directory."
			EndIf
			If( StringMatch( DepthScale, "CCSF" ) || StringMatch( DepthScale, "CCSFA" ) || StringMatch( DepthScale, "MCD" ))
				MatrixLayer = 2				// MatrixLayer defines whether CSF or CCSF was selected as the depth scale 0 = CSF, 2 = CCSF per layers in the coring matrix
			EndIf
			If( StringMatch( CCInclude, "Y" ) ) // This determines whether CC depths are included as the function works through the coring matrix
				CC = 10  // searches through column 9
			Else
				CC = 9 //  searches only columns 1 - 8
			EndIf
			For( i = 1; i < DimSize( CMatrix, 0 ); i += 1 )  // Variable i steps through the coring matrix row by row
				For( j = 1; j < CC; j += 1 )										// Variable j steps through each section in the row defined by i
					If( CMatrix[ i ][ j ][ MatrixLayer ] + CMatrix[ i ][ j ][ 1 ] > Depth ) // This line adds section length to each section depth and then checks to see if it exceeds the input depth.
						Interval = Round( ( Depth - CMatrix[ i ][ ( j ) ][ MatrixLayer ] ) * 100 )  // Interval is calculated by section depth from input depth	
						If( Interval < 0 ) // Once the section depth + section length is > input depth the loop breaks
							Break;
						EndIf
						// Results are printed to History.
						CSF = CMatrix[ i ][ j ][ 0 ] + Interval / 100; CCSF = CMatrix[ i ][ j ][ 2 ] + Interval / 100
						String CSIoutput1, CSIoutput2
						sprintf CSIoutput1, "%s%s %dH", RemoveEnding( Hole ), HoleLetter, i
						sprintf CSIoutput2, " %d %.0f (%.2f)", j, Interval, CSF
						V1 += 1; // Increments each time the results for an input depth are printed. See below
						Break;
					EndIf
				EndFor
			EndFor
			If( V1 > 1 ) // If there was more than 1 result, a message is printed.
				DoAlert 0, "There is more than 1 solution for depth " + Num2Str( Depth ) +". \rThis is probably the result of overlap in core depth ranges.";
			ElseIf( V1 == 0 )
				DoAlert 0, Num2Str( Depth ) + " falls outside of the ranges of recovered cores in " + Hole
			EndIf
		
		String CSIstring = CSIoutput1 + CSIoutput2
		Return CSIstring		
	EndMacro



	
	
	
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

//Original function
	
//	Function Shift_Offsets_B_2_A( )
		SetDataFolder root:
			String S_Site, S_Hole, S_Technique, S_Offsets, S_Core, S_FolderList, S_Folder, S_Data
			Variable V1, V2, i, V_Core, V_Offset, SLen
			Variable/G G_V1, G_Core
			String/G G_S1
			PauseUpdate;
			If(!StrLen( CsrWave( B ) ) || !StrLen( CsrWave( A ) ) )
				Abort "Cursor(s) Not on Graph"
			EndIf		
			If( DimSize( CsrWaveRef( B ), 1 ) )
				S_Hole = ImageHole( CsrWave( B ) )
				V_Core = ImageCore( CsrWave( B ) )
			Else
				S_Hole = DataWaveHole( CsrWave( B ) )
				S_Site = RemoveEnding( S_Hole )
				S_Technique = DataWaveTechnique( CsrWave( B ) )
		SetDataFolder $S_Site + "_" + S_Technique
				Wave CoreWv = $S_Hole + "_" + S_Technique + "_" + "Core"
		SetDataFolder root:
				V_Core = CoreWv[ PCsr( B ) ]
			EndIf
			S_Offsets = S_Hole + "_Offsets"
			WAVE Offsets = $S_Offsets
			Duplicate/O Offsets Offset_Undo
			NOTE/K Offset_Undo, S_Offsets
			V_Offset = HCsr( B ) - HCsr( A )
			Offsets[ V_Core, ] -= V_Offset
			Print S_Hole, V_Core, V_Offset
	End	
	
