﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function AgeModelTies( )
		SetDataFolder root:
			Variable/G G_AgeIncrement
			Variable AgeIncrement = G_AgeIncrement
			String/G G_BaseFolder, G_StretchFolder, G_BaseAge, G_BaseDepth, G_StretchAge, G_StretchDepth
			String BaseFolder = G_BaseFolder, BaseAge = G_BaseAge, BaseDepth = G_BaseDepth
			String StretchFolder = G_StretchFolder, StretchAge = G_StretchAge, StretchDepth = G_StretchDepth
			Prompt BaseFolder, "Base Site Age Model DataFolder", popup, FolderList( "*" )
			Prompt StretchFolder, "Stretch Site Age Model DataFolder", popup, FolderList( "*" )
			Prompt AgeIncrement, "Age increment for ties in MYrs (e.g. .1 for 100,000 yrs ):"
			DoPrompt "AgeModelTies", BaseFolder, StretchFolder, AgeIncrement
			G_BaseFolder = BaseFolder; G_StretchFolder = StretchFolder;
			G_AgeIncrement = AgeIncrement
			G_StretchAge = StretchAge, G_StretchDepth = StretchDepth
			AbortOnValue V_Flag, 0
			DFREF BaseDFR = $BaseFolder, StretchDFR = $StretchFolder
		SetDataFolder BaseDFR
			Prompt BaseAge, "Select Base Site Age wave:", popup, SortList( WaveList( "*", ";", "" ) )
			Prompt BaseDepth, "Select Base Site Depth wave:", popup, SortList( WaveList( "*", ";", "" ) )
			DoPrompt "AgeModelTies", BaseAge, BaseDepth
			G_BaseAge = BaseAge; G_BaseDepth = BaseDepth
			If( V_Flag > 0 )
				SetDataFolder root:
				ABORT
			EndIf
			WAVE BaseAgeWv = $BaseAge, BaseDepthWv = $BaseDepth
		SetDataFolder StretchDFR
			Prompt StretchAge, "Select Stretch Site Age Wave:", popup, SortList( WaveList( "*", ";", "" ) )
			Prompt StretchDepth, "Select Stretch Site Depth Wave:", popup, SortList( WaveList( "*", ";", "" ) )
			DoPrompt "AgeModelTies", StretchAge, StretchDepth
			G_StretchAge = StretchAge; G_StretchDepth = StretchDepth
			If( V_Flag > 0 )
				SetDataFolder root:
				ABORT
			EndIf
			WAVE StretchAgeWv = $StretchAge, StretchDepthWv = $StretchDepth
		SetDataFolder root:
			Variable BaseAgeMax = WaveMax( BaseAgeWv ), StretchAgeMax = WaveMax( StretchAgeWv )
			Variable AgeMin = Min( BaseAgemax, StretchAgeMax )
		NewDataFolder/O/S AgeModelTies
			Make/O/N = ( AgeMin / AgeIncrement ) Ages, BaseAgeTies, StretchAgeTies
			Make/T/O/N = ( AgeMin / AgeIncrement ) AgeTieTypes
			AgeTieTypes = "Models"
			Ages = AgeIncrement * x
			BaseAgeTies = Interp( Ages, BaseAgeWv, BaseDepthWv )
			StretchAgeTies = Interp( Ages, StretchAgeWv, StretchDepthWv )
			BaseAgeTies[ 0 ] = 0; StretchAgeTies[ 0 ] = 0
			Duplicate/O BaseAgeTies AgeTiesOnes
			AgeTiesOnes = 1
		SetDataFolder root:
			WAVE BaseTies, StretchTies
			WAVE/T TieType
			If( !WaveExists( BaseTies ) )
				Make/N = 0 BaseTies, StretchTies
				Make/T/N = 0 TieType
			EndIf
	End	