#pragma rtGlobals=3		// Use modern global access method.


***************************************************
	
	Function Power_Window() : Graph
		If( ( StrSearch( WinList( "*", ";", "WIN:1" ) , "PowerWindow", 0 ) + 1 )  )
			DoWindow/F PowerWindow
		Else
			SetDataFolder root:
				Variable/G G_Sed_Rate, G_CsrADepth
			SetDataFolder root:Xtras:
				WAVE Power, Ones, Freq
			SetDataFolder root:
				Display /W=(1407,880,2213,1253)/K=1  Power as "Power_Window"
				AppendToGraph/R Ones vs Freq
				ModifyGraph mode(Ones)=1
				ModifyGraph lSize(Power)=3,lSize(Ones)=2
				ModifyGraph rgb(Power)=(0,0,0)
				ModifyGraph grid(left)=1,grid(bottom)=1
				ModifyGraph mirror(bottom)=2
				ModifyGraph minor(left)=1,minor(bottom)=1
				ModifyGraph axOffset(bottom)=0.25
				Label bottom "\\Z14\\f01Cycles/m"
				SetAxis bottom 0,3.5
				SetAxis right 0,2
				Cursor/P A Power 15
				ShowInfo
				SetVariable setvar0, pos = { 87, 33 }, size = {160, 24 },title = "Sed_Rate", fSize = 16
				print G_Sed_Rate
				SetVariable setvar0, format = "%0.1f", limits = { 0, 200, 0.1 }, value = G_Sed_Rate
				NewPanel/W = ( 0.665, 0.077, 0.838, 0.195 )/HOST = # 
				ModifyPanel frameInset=1
				ValDisplay valdisp0,pos={8,9},size={112,20},title="Depth",fSize=14
				ValDisplay valdisp0,format="%0.2f",limits={0,0,0},barmisc={0,1000}
				ValDisplay valdisp0,value= #"G_CsrADepth"
				RenameWindow #,P0
				SetActiveSubwindow ##
				DoWindow/C PowerWindow
			EndIf
	EndMacro
	

***************************************************
	
	Function AgePower() : Graph
		If( ( StrSearch( WinList( "*", ";", "WIN:1" ) , "PowerWindow", 0 ) + 1 )  )
			DoWindow/F PowerWindow
		Else
			SetDataFolder root:
				Variable/G G_Sed_Rate, G_CsrADepth
			SetDataFolder root:Xtras
				WAVE Power, Ones, Freq, SpecAgeMax, Freq4Plotting
			SetDataFolder root:
				Display /W=(1407,880,2213,1253)/K=1  Power as "Age_Power_Window"
				ModifyGraph lSize(Power)=3//,lSize(Ones)=2
				ModifyGraph rgb(Power)=(0,0,0)
				ModifyGraph grid(left)=1,grid(bottom)=1
				ModifyGraph mirror(bottom)=2
				ModifyGraph minor(left)=1,minor(bottom)=1
				ModifyGraph axOffset(bottom)=0.25
				Label bottom "\\Z14\\f01Cycles/Myrs"
				SetAxis bottom 0,100
				ShowInfo
				DoWindow/C/F AgePowerWindow
				If( StrSearch( TraceNameList( "", ";", 3 ),"SpecAgeMax",  0 ) == -1 )
					AppendToGraph Ones vs Freq4Plotting
					ModifyGraph mode(Ones)=1,lsize(Ones)=3
				EndIf
			EndIf
	EndMacro
	
	******************************************
		
	Window Sed_Rate_Table() : Table
		PauseUpdate; Silent 1		// building window...
		Edit/W=(529,524,1079,944) Inst_Sed_Rate,Inst_R_S,Inst_R_S_Age,Freq_MCD
		ModifyTable format(Point)=1
	EndMacro

----------------------------------------------------
	
	Function Norm_Amp() : Graph
		Display /W=(1408,128,2173,826)/K=1 
		WAVE Nmatrix = $"root:Xtras:Nmatrix"
		AppendImage Nmatrix
		ModifyImage Nmatrix ctab= {*,*,Terrain,1}
		ModifyGraph wbRGB=(49151,65535,49151)
		ModifyGraph grid(bottom)=1
		ModifyGraph mirror(left)=2,mirror(bottom)=1
		ModifyGraph minor=1
		ModifyGraph gridStyle(bottom)=3
		Label bottom "Cycles/m"
		SetAxis bottom 0,3.5
		SetAxis/A/R left
		ShowInfo
		DoWindow/C NormAmp
		Set_Cursors_Black()
	End

-----------------------------------------------
	
	Function Norm_Amp_Freq( DataWave ) 
		WAVE DataWave
			String Data = NameOfWave( DataWave )
			DFREF DataFolder = $RemoveEnding( FirstPart( Data ) ) + "_" + SecondPart( Data )
		SetDataFolder DataFolder
			Duplicate/O DataWave $RemoveEnding( NameOfWave( DataWave ) ) + "Depth"
			WAVE DataDepth = $RemoveEnding( NameOfWave( DataWave ) ) + "Depth"
			DataDepth = x
		SetDataFolder root:
		Display/N = NormAmpFreq /W=(1408,128,2173,826)/K=1 
		WAVE Nmatrix = $"root:Xtras:Nmatrix"
		AppendImage/L = DepthAxis/B = FreqAxis Nmatrix
		ModifyImage Nmatrix ctab= {*,*,Terrain,1}
		ModifyGraph wbRGB=(49151,65535,49151)
		ModifyGraph grid(FreqAxis)=1
		ModifyGraph mirror(DepthAxis)=2,mirror(FreqAxis)=1
		ModifyGraph minor=1
		ModifyGraph gridStyle(FreqAxis)=3
		Label FreqAxis "Cycles/m"
		Label DepthAxis "Depth";DelayUpdate
		ModifyGraph lblPosMode=4,lblPos=50
		SetAxis FreqAxis 0,3.5
		SetAxis/A/R DepthAxis
		ModifyGraph freePos=0
		If( StrLen( ContourNameList( "", ";" ) ) )
			RemoveContour NMatrix
		EndIf
		AppendMatrixContour/L = DepthAxis/B = FreqAxis Nmatrix; DelayUpdate
		ModifyGraph axisEnab(FreqAxis)={0,0.8}
		ModifyContour Nmatrix labels=0, ManLevels = { 0.1, 0.15, 10 }
		AppendToGraph/L=DepthAxis/B=DataAxis DataDepth vs DataWave
		ModifyGraph tick(DataAxis)=3,noLabel(DataAxis)=1,lblPos(DataAxis)=30,axisEnab(DataAxis)={0.8,1},freePos(DataAxis)=0;DelayUpdate
		Label DataAxis "Data"		
		Set_Cursors_Black()	
		ShowInfo
	EndMacro

----------------------------------------------------
	
	Function Norm_Amp_Depth( DataWave ) : Graph
		WAVE DataWave
			String Data = NameOfWave( DataWave )
			DFREF DataFolder = $RemoveEnding( FirstPart( Data ) ) + "_" + SecondPart( Data )
		SetDataFolder DataFolder
			Duplicate/O DataWave $RemoveEnding( NameOfWave( DataWave ) ) + "Depth"
			WAVE DataDepth = $RemoveEnding( NameOfWave( DataWave ) ) + "Depth"
			DataDepth = x
		SetDataFolder root:
		Display/N = NormAmpDepth /W=(1408,128,2173,826)/K=1 
		WAVE Nmatrix = $"root:Xtras:Nmatrix"
		AppendImage/L = DepthAxis/B = FreqAxis Nmatrix
		ModifyImage Nmatrix ctab= {*,*,Terrain,1}
		ModifyGraph wbRGB=(49151,65535,49151)
		ModifyGraph grid(FreqAxis)=1
		ModifyGraph mirror(DepthAxis)=2,mirror(FreqAxis)=1
		ModifyGraph minor=1
		ModifyGraph gridStyle(FreqAxis)=3
		Label FreqAxis "Cycles/m"
		Label DepthAxis "Depth";DelayUpdate
		ModifyGraph lblPosMode=4,lblPos=50
		SetAxis FreqAxis 0,3.5
		SetAxis/A DepthAxis
		ModifyGraph freePos=0
		If( StrLen( ContourNameList( "", ";" ) ) )
			RemoveContour NMatrix
		EndIf
		AppendMatrixContour/L = DepthAxis/B = FreqAxis Nmatrix; DelayUpdate
		ModifyGraph axisEnab(FreqAxis)={0,0.8}
		ModifyContour Nmatrix labels=0, ManLevels = { 0.1, 0.15, 10 }
		AppendToGraph/L=DepthAxis/B=DataAxis DataDepth vs DataWave
		ModifyGraph tick(DataAxis)=3,noLabel(DataAxis)=1,lblPos(DataAxis)=30,axisEnab(DataAxis)={0.8,1},freePos(DataAxis)=0;DelayUpdate
		Label DataAxis "Data"			
		ModifyGraph swapXY=1
		Set_Cursors_Black()
		ShowInfo
	EndMacro

-----------------------------------------------
	
	Function NormFreqAmp( DataWave ) 
		WAVE DataWave
			String Data = NameOfWave( DataWave )
			DFREF DataFolder = $RemoveEnding( FirstPart( Data ) ) + "_" + SecondPart( Data )
		SetDataFolder DataFolder
			Duplicate/O DataWave $RemoveEnding( NameOfWave( DataWave ) ) + "Age"
			WAVE DataAge = $RemoveEnding( NameOfWave( DataWave ) ) + "Age"
			DataAge = x
		SetDataFolder root:
		Display/N = NormAmpFreq /W=(1408,128,2173,826)/K=1 
		WAVE Nmatrix = $"root:Xtras:Nmatrix"
		AppendImage/L = AgeAxis/B = FreqAxis Nmatrix
		ModifyImage Nmatrix ctab= {*,*,Terrain,1}
		ModifyGraph wbRGB=(49151,65535,49151)
		ModifyGraph grid(FreqAxis)=1
		ModifyGraph mirror(AgeAxis)=2,mirror(FreqAxis)=1
		ModifyGraph minor=1
		ModifyGraph gridStyle(FreqAxis)=3
		Label FreqAxis "Cycles/my"
		Label AgeAxis "Age";DelayUpdate
		ModifyGraph lblPosMode=4,lblPos=50
		SetAxis FreqAxis 0,200
		SetAxis/A/R AgeAxis
		ModifyGraph freePos=0
		If( StrLen( ContourNameList( "", ";" ) ) )
			RemoveContour NMatrix
		EndIf
		AppendMatrixContour/L = AgeAxis/B = FreqAxis Nmatrix; DelayUpdate
		ModifyGraph axisEnab(FreqAxis)={0,0.8}
		ModifyContour Nmatrix labels=0, ManLevels = { 0.1, 0.15, 10 }
		AppendToGraph/L=AgeAxis/B=DataAxis DataAge vs DataWave
		ModifyGraph tick(DataAxis)=3,noLabel(DataAxis)=1,lblPos(DataAxis)=30,axisEnab(DataAxis)={0.8,1},freePos(DataAxis)=0;DelayUpdate
		Label DataAxis "Data"		
		Set_Cursors_Black()	
		ShowInfo
	EndMacro

----------------------------------------------------
	
	Function NormAgeAmp( DataWave ) : Graph
		WAVE DataWave
			String Data = NameOfWave( DataWave )
			DFREF DataFolder = $RemoveEnding( FirstPart( Data ) ) + "_" + SecondPart( Data )
		SetDataFolder DataFolder
			Duplicate/O DataWave $RemoveEnding( NameOfWave( DataWave ) ) + "Age"
			WAVE DataAge = $RemoveEnding( NameOfWave( DataWave ) ) + "Age"
			DataAge = x
		SetDataFolder root:
		Display/N = NormAmpAge /W=(1408,128,2173,826)/K=1 
		WAVE Nmatrix = $"root:Xtras:Nmatrix"
		AppendImage/L = AgeAxis/B = FreqAxis Nmatrix
		ModifyImage Nmatrix ctab= {*,*,Terrain,1}
		ModifyGraph wbRGB=(49151,65535,49151)
		ModifyGraph grid(FreqAxis)=1
		ModifyGraph mirror(AgeAxis)=2,mirror(FreqAxis)=1
		ModifyGraph minor=1
		ModifyGraph gridStyle(FreqAxis)=3
		Label FreqAxis "Cycles/my"
		Label AgeAxis "Age";DelayUpdate
		ModifyGraph lblPosMode=4,lblPos=50
		SetAxis FreqAxis 0,200
		SetAxis/A AgeAxis
		ModifyGraph freePos=0
		If( StrLen( ContourNameList( "", ";" ) ) )
			RemoveContour NMatrix
		EndIf
		AppendMatrixContour/L = AgeAxis/B = FreqAxis Nmatrix; DelayUpdate
		ModifyGraph axisEnab(FreqAxis)={0,0.8}
		ModifyContour Nmatrix labels=0, ManLevels = { 0.1, 0.15, 10 }
		AppendToGraph/L=AgeAxis/B=DataAxis DataAge vs DataWave
		ModifyGraph tick(DataAxis)=3,noLabel(DataAxis)=1,lblPos(DataAxis)=30,axisEnab(DataAxis)={0.8,1},freePos(DataAxis)=0;DelayUpdate
		Label DataAxis "Data"			
		ModifyGraph swapXY=1
		Set_Cursors_Black()
		ShowInfo
	EndMacro

----------------------------------------------------

	Function True_Amp() : Graph
		PauseUpdate; Silent 1	
		WAVE Pmatrix = $":root:Xtras:Pmatrix"
		Display /W=(377,257,626,489) as "True_amp"
		AppendImage Pmatrix
		ModifyImage Pmatrix ctab= {*,*,Rainbow,0}
		ModifyGraph minor=1
		SetAxis/A/R left
		Textbox/N=text0/F=0/A=MC/X=33.09/Y=42.06 ""
	EndMacro

----------------------------------------------------
	
	Window Spectrogram_Data() : Graph
		PauseUpdate; Silent 1		// building window...
		Display /W=(35,45,430,253) U1338_Splice_GRA_GRA_I_R
		ShowInfo
	EndMacro

-----------------------------------------------

