#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function Splice_Data(  )
		SetDataFolder root:
			String Site, Technique, Splice_Format, SpliceOrS
			String/G G_Site, G_Technique, G_SpliceOrS
			Site = G_Site,  Technique = G_Technique,  Splice_Format  =  "Splice_Intervals", SpliceOrS = G_SpliceOrS
			Prompt Splice_Format,  "Use Splice Ties or Splice Intervals Format?",  popup,  "Splice_Intervals;Splice_Ties"
			Prompt Site, "Site"
			Prompt Technique, "Technique"
			Prompt SpliceOrS, "Use _Splice or S for Spliced Data Names", popup, "S;Splice"
			DoPrompt "Splice_Data", Site, Technique, SpliceOrS, Splice_Format; AbortOnValue V_Flag, 0
			G_Site = Site; G_Technique = Technique; G_SpliceOrS = SpliceOrS
			If( StringMatch( SpliceOrS, "Splice" ) )
//				Splice_Data_F( Site, Technique, Splice_Format )
				Print "Splice_Data_F( \"" + Site + "\", \"" + Technique + "\", \"" + Splice_Format + "\")"
			Else
				Splice_Data_S( Site, Technique, Splice_Format )
				Print "Splice_Data_S( \"" + Site + "\", \"" + Technique + "\", \"" + Splice_Format + "\")"
			EndIf
	End
	
-------------------------------------------------------------------
	
	// Last changed 16/6/17 to correct bug that missed first interval of data. Also instituted For-EndFor loops in place of Do-Whiles.
		
	Function Splice_Data_S( Site, Technique, Splice_Format )
		String Site, Technique,  Splice_Format
		SetDataFolder root:
			Variable i = 0,  j = 0, k = 0
			String S1,  S2,  S3, Hole
			String WList, W1, WvName, SplWave
			Variable V1, V2, V3,  V4
			If( !DataFolderExists( Site + "_" + Splice_Format ) )
				Print "I can't find the folder " + Site + "_" + Splice_Format
				Abort "I can't find the folder " + Site + "_" + Splice_Format
			Endif
			If( SpliceDataCheck( Site, Splice_Format ) ) // This is a separate function to check the splice tables, both intervals and ties.
				Abort
			Endif
			Wave/T HoleWave = $"root:" + Site + "_" + Splice_Format + ":Hole_Top"
			For( i = 0; i < NumPnts( HoleWave ); i += 1 ) // This loop checks to see that all of the matrices have CCSF values
				Hole = Site + HoleWave[i]
				CheckMatrix4CCSF( Hole )
			EndFor
		SetDataFolder $Site + "_" + Technique
			CCSFNaNCheck()  // This function checks to see if there are blanks in the depth waves. They might cause a problem if they are within splice intervals.
			PauseUpdate;		
// This section creates a list of CCSF waves that the function uses to determine how many holes there are and what they are ( A, B, etc ).
// It then generates a list of all of the waves from the first listed hole ( generally Hole "A", but not always ).		
		
			String HoleList = "", CCSFList = "", CCSFWv, DataList, DataWave, TemplateHole
			String CCSFWvList = SortList( WaveList( "*CCSF*", ";", "" ) )
			For( k = 0; k < ItemsInList( CCSFWvList ); k += 1 )  		// Forms a list of Holes from CCSF waves,skiping the Spliced CCSF wave if it already exists
				CCSFWv = StringFromList( k, CCSFWvList )
				If( !Stringmatch( CCSFWv , "*Splice*" ) && !Stringmatch( CCSFWv , Site + "S*" ) )
					CCSFList = CCSFList + StringFromList( k, CCSFWvList ) + ";"
					HoleList = HoleList + DataWaveHole( StringFromList( k, CCSFWvList ) ) + ";"
				Endif
			EndFor
			CCSFList = RemoveEnding( CCSFList )	
			HoleList = RemoveEnding( HoleList )	
			TemplateHole = StringFromList( 0, HoleList )
			For( k = 0; 1; k += 1 )     // Here the data list is formed from the first listed hole, as a template for all holes, of the data needing to be spliced.
				WvName = StringFromList( k, HoleList )  
		 		If( !Stringmatch( WvName, "*Splice*" ) && !Stringmatch( WvName , Site + "S*" ) )	// Skips the "Splice" waves
					DataList = WaveList( "*" + WvName + "*", ";", "" )
					Break;  // After the data waves from the first hole are listed in DataList the loop breaks.
				Endif
			EndFor

 // This loop checks to see that the same data waves that were in the first hole are present in the rest of the holes.				
	 		 // i cycles through the holes. It is set to 1 to skip the data from the first hole which serves as the template (above).
			For( i = 1; i < ItemsInList( CCSFList ); i += 1 )
				For( k = 0; k < ItemsInList( DataList ); k += 1 )  // k cycles through the data waves to see if each hole has the same data waves as the first.
					WvName =  StringFromList( k, DataList )
					DataWave = StringFromList( i, HoleList )  + "_" + DataWaveTechnique( WvName ) + "_" + DataWaveData( WvName )
					If( !Exists( DataWave ) && !Stringmatch( WvName, "*Splice*" ) && !Stringmatch( WvName , Site + "S*" ) ) // Skips spliced waves
						DoAlert/T = "Data Problem" 1, "I can't find " + DataWave + "\r\rDo you want to continue?"
						Print  "I can't find " + DataWave
						AbortOnValue ( V_flag - 1 ), 0
					Endif 
				EndFor
			EndFor
// Now to see if there are data waves in the subsequent holes that are not in the first hole
			For( i = 1; i < ItemsInList( HoleList ); i += 1 )
				WList = WaveList( StringFromList( i, HoleList ) + "*", ";", "" )
				For( j = 0; J < itemsInList( WList ); j += 1 )
					WvName = ReplaceString( StringFromList( i, HoleList ), StringFromList( j, WList ), TemplateHole )			
					If( !Exists( WvName ) )
						DoAlert/T = "Data Problem" 1, "I can't find the equivalent of " + StringFromList( j, WList ) + " in the " + TemplateHole + " data\r\rDo you want to continue?"
						Print  "I can't find the equivalent of " + StringFromList( j, WList ) + " in the " + TemplateHole + " data\r"
						AbortOnValue ( V_flag - 1 ), 0
					EndIf
				EndFor
			EndFor
								
//  This section creates Spliced waves for each data type and C, S, I if they do not already exist.
//		Existing waves are set to zero length.
		
			WvName = StringFromList( 0, WaveList( "*_CCSF", ";", "" ) )  
			WList = WaveList( DataWaveHole( WvName ) + "_*", ";", "" )
	
			SplWave = Site + "S_" + DataWaveTechnique( WvName ) + "_" + DataWaveData( WvName )
			If ( Exists( SplWave ) )
				For( i = 0; 1; i += 1 )
					WvName = stringFromList( i, WList )
					SplWave = Site + "S_" + DataWaveTechnique( WvName ) + "_" + DataWaveData( WvName )
					If( StrLen( WvName ) < 2 )
						break;
					EndIf
					ReDimension/N = 0 $SplWave
				EndFor
			Else
				For( i = 0; 1; i += 1 )
					WvName = stringFromList( i, WList )
					SplWave = Site + "S_" + DataWaveTechnique( WvName ) + "_" + DataWaveData( WvName )
					If( StrLen( WvName ) < 2 )
						break;
					EndIf
					If( WaveType( $WvName ) )	
						Make/O/N = 0 $SplWave
					Else
						Make/O/T/N = 0 $SplWave
					EndIf
				EndFor
			EndIf
		
// This section checks to see where CCSF from the appropriate hole matches splice interval
			
			i = 0; j = 0; k = 0
			String Splice_Data,  CCSF_Wave, Splice_Waves, Splice_Waves_TEXT
			Variable Splice_Bottom,  Splice_Top
			Splice_Waves = WaveList( Site + "S*", ";", "TEXT:0" )
			Splice_Waves_TEXT = WaveList( Site + "S*",";", "TEXT:1" )
			Splice_Data  = "root:" + Site + "_"  +  Splice_Format	  // Data Folder Name for splice data, either ties or intervals

//			For( i = 0; i < 2; i += 1 )
			For( i = 0; i < NumPnts( $Splice_Data + ":CCSF_Bottom"  ); i += 1 )
				If( StringMatch( Splice_Format, "Splice_Intervals" )  )
					Hole = Splice_Interval_Hole( Site, i )
				Else	
					Hole = Splice_Tie_Hole( Site, i )
				EndIf
				Make/O/N = 0 Data1, Data2, Data3	
				CCSFWv = Site + Hole + "_" + Technique + "_CCSF"
				
				If( !Exists( CCSFWv ) ) // This loop checks to see whether the DataWave from the hole containing the interval exists. 
					i += 1									// Sometimes data, like XRF, are only collected over a limited interval and may not have data 
					If( i >= NumPnts( $Splice_Data + ":CCSF_Bottom"  ) ) // for each hole involved in the complete splice. Data from
						Break;															  				// missing waves is skipped.	
					EndIf
					Continue
				EndIf
				
				Duplicate/O $CCSFWv Data1, Data2, Data3
				If( StringMatch( Splice_Format, "Splice_Intervals" )  )
					Splice_Top = Splice_Interval_Top( Site, i )
					Splice_Bottom = Splice_Interval_Bottom( Site, i )
				Else
					Splice_Top = Splice_Tie_Top( Site, i )
					Splice_Bottom = Splice_Tie_Bottom( Site, i )
				EndIf
	
//  Data2 is a Mask of 1's and 0's with the 1's identifying the  CCSF and Core that agree with splice section

				WAVE IntervalCoreWave = $Site + Hole + "_" + Technique + "_Core", TieCoreWave = $Site + Hole + "_" + Technique + "_Core" 
	
				If( StringMatch( Splice_Format, "Splice_Intervals" )  )
					Data2 = ( ( Data1 >= Splice_Top ) && ( Data1 < Splice_Bottom ) && ( IntervalCoreWave == Splice_Interval_Core( Site, i ) ) )
				Else
					Data2 = ( ( Data1 >= Splice_Top ) && ( Data1 < Splice_Bottom ) && ( TieCoreWave == Splice_Tie_Core( Site, i ) ) )
				EndIf
				FindLevel/Q Data2,  1  //Finds start of data
				V4 = V_Flag
				V1 = V_LevelX
				If( i == 0 ) // Special case of first interval of data because FindLevel doesn't work when point [0] is 1.
					V1 = 0
				EndIf
				FindLevel/Q/R = [ V1 + 1 ] Data2,  0  // Finds end of data
				V2 = V_LevelX-1
				V3 = StrLen( Site ) + 2 + StrLen( Technique ) + 1

// This is the numeric loop. V4 tells it to skip this section if there are no data from the hole.
		
				If( !V4 )
					For( j = 0; j < ItemsInList( Splice_Waves ); j += 1 )
						WvName = StringFromList( j, Splice_Waves )
						If( StrLen( WvName ) < 2 )
							Break;
						EndIf
						S3 = WvName[ V3, StrLen( WvName ) ]
						If( !StringMatch( S3, "Hole_Index" ) )
							If( !StringMatch( S3, "Age" ) )
							Duplicate/O/R = [ V1, ( V2 ) ]  $Site + Hole + "_" + Technique + "_" + S3  Temp
							EXECUTE "Concatenate {Temp},  " + WvName
							EndIf
						EndIf
					EndFor
	
//  This is the text loop
			
					For( j = 0; j < ItemsInList( Splice_Waves_TEXT ); j += 1 )
						WvName = StringFromList( j, Splice_Waves_TEXT )
						S3 = WvName[V3, StrLen( WvName )]
						Duplicate/O/R = [V1, ( V2 )]  $Site + Hole + "_" + Technique + "_" + S3  TTemp
						EXECUTE "Concatenate {TTemp},  " + WvName
					EndFor
				EndIf
			EndFor
			KillWaves/Z Data1, Data2, Data3,  Temp,  TTemp
			Hole_2_Index_S( Site, Technique )
		SetDataFolder root:
	EndMacro
	
-------------------------------------------------------------------
	
	Function Splice_Data_F( Site, Technique, Splice_Format )
		String Site, Technique,  Splice_Format
		SetDataFolder root:
			Variable i = 0,  j = 0, k = 0
			String S1,  S2,  S3
			String WList, W1, Hole
			Variable V1, V2, V3,  V4
			If( SpliceDataCheck( Site, Splice_Format ) ) // This is a separate function to check the splice tables, both intervals and ties.
				Abort
			Endif
			Wave/T HoleWave = $"root:" + Site + "_" + Splice_Format + ":Hole_Top"
			For( i = 0; i < NumPnts( HoleWave ); i += 1 )
				Hole = Site + HoleWave[i]
				CheckMatrix4CCSF( Hole )
			EndFor
		SetDataFolder $Site + "_" + Technique
			CCSFNaNCheck()  // This function checks to see if there are blanks in the depth waves. They might cause a problem if they are within splice intervals.
			PauseUpdate;
		
// This section creates a list of CCSF waves that the function uses to determine how many holes there are and what they are ( A, B, etc ).
// It then generates a list of all of the waves from the first listed hole ( generally Hole "A", but not always ).		
		
			String HoleList = "", CCSFList = "", DataList, DataWave, TemplateHole
			
			k = 0;
			Do  		// Forms a list of Holes from CCSF waves,skiping the Spliced CCSF wave if it already exists
				S1 = SortList( WaveList( "*CCSF*", ";", "" ) )
				S2 = StringFromList( k, S1 )
				If( !Stringmatch( S2 , "*Splice*" ) && !Stringmatch( S2 , Site + "S*" ) )
					CCSFList = CCSFList + StringFromList( k, S1 ) + ";"
					HoleLIst = HoleList + DataWaveHole( StringFromList( k, S1 ) ) + ";"
				Endif
				k += 1;
			While( k < ItemsInList( S1 ) )
			CCSFList = RemoveEnding( CCSFList )	
			HoleList = RemoveEnding( HoleList )	
			TemplateHole = StringFromList( 0, HoleList )
			k = 0;
			Do    // Here the data list is formed from the first listed hole, as a template for all holes, of the data needing to be spliced.
				S2 = StringFromList( k, HoleList )  
		 		If( !Stringmatch( S2, "*Splice*" ) && !Stringmatch( S2 , Site + "S*" ) )	// Skips the "Splice" waves
					DataList = WaveList( "*" + S2 + "*", ";", "" )
					Break;  // After the data waves from the first hole are listed in DataList the loop breaks.
				Endif
				k += 1;
			While( 1 )

// This loop checks to see that the same data waves that were in the first hole are present in the rest of the holes.				

	 		i = 1; // i cycles through the holes. It is set to 1 to skip the data from the first hole which serves as the template (above).
			Do
				k = 0; // k cycles through the data waves to see if each hole has the same data waves as the first.
				Do
					S2 =  StringFromList( k, DataList )
					DataWave = StringFromList( i, HoleList )  + "_" + DataWaveTechnique( S2 ) + "_" + DataWaveData( S2 )
					If( !Exists( DataWave ) && !Stringmatch( S2, "*Splice*" ) && !Stringmatch( S2 , Site + "S*" ) )
						DoAlert/T = "Data Problem" 1, "I can't find " + DataWave + "\r\rDo you want to continue?"
						Print  "I can't find " + DataWave
						AbortOnValue ( V_flag - 1 ), 0
					Endif 
					k += 1;
				While( k < ItemsInList( DataList ) )		
				i += 1;
			While( i < ItemsInList( CCSFList ) )

// Now to see if there are data waves in the subsequent holes that are not in the first hole

			i = 1;
			Do
				S1 = RemoveEnding( WaveList( StringFromList( i, HoleList ) + "*", ";", "" ) )
				j = 0;
				Do
					S2 = ReplaceString( StringFromList( i, HoleList ), StringFromList( j, S1 ), TemplateHole )			
					If( !Exists( S2 ) )
						DoAlert/T = "Data Problem" 1, "I can't find the equivalent of " + StringFromList( j, S1 ) + " in the " + TemplateHole + " data\r\rDo you want to continue?"
						Print  "I can't find the equivalent of " + StringFromList( j, S1 ) + " in the " + TemplateHole + " data\r"
						AbortOnValue ( V_flag - 1 ), 0
					EndIf
					j += 1;
				While( J < ( itemsInList( S1 ) ) )
				i += 1;
			While( i < ItemsInList( HoleList ) )
				
//  This section creates Spliced waves for each data type and C, S, I if they do not already exist.
		
			S2 = StringFromList( 0, WaveList( "*_CCSF", ";", "" ) )  
			WList = WaveList( DataWaveHole( S2 ) + "_*", ";", "" )
	
			S3 = Site + "_Splice_" + DataWaveTechnique( S2 ) + "_" + DataWaveData( S2 )
			i = 0
			If ( Exists( S3 ) )
				Do
					S2 = StringFromList( i, WList )
					S3 = Site + "_Splice_" + DataWaveTechnique( S2 ) + "_" + DataWaveData( S2 )
					If( StrLen( S2 ) < 2 )
						break;
					EndIf
					ReDimension/N = 0 $S3
					i += 1
				While( 1 )
			Else
				Do
					S2 = stringFromList( i, WList )
					S3 = Site + "_Splice_" + DataWaveTechnique( S2 ) + "_" + DataWaveData( S2 )		
					If( StrLen( S2 )<2 )
						break;
					EndIf
					If( WaveType( $S2 ) )	
						Make/O/N = 0 $S3
					Else
						Make/O/T/N = 0 $S3
					EndIf
					i += 1
				While( 1 )
			EndIf
		
// This section checks to see where CCSF from the appropriate hole matches splice interval
			
			i = 0; j = 0; k = 0
			String Splice_Data,  CCSF_Wave, Splice_Waves, Splice_Waves_TEXT
			Variable Splice_Bottom,  Splice_Top
			Splice_Waves = WaveList( "*Splice*", ";", "TEXT:0" )
			Splice_Waves_TEXT = WaveList( "*Splice*", ";", "TEXT:1" )
			Splice_Data  = "root:" + Site + "_"  +  Splice_Format	  // Data Folder Name for splice data, either ties or intervals
	
			Do
				If( StringMatch( Splice_Format, "Splice_Intervals" )  )
					Hole = Splice_Interval_Hole( Site, i )
				Else	
					Hole = Splice_Tie_Hole( Site, i )
				EndIf
				Make/O/N = 0 Data1, Data2, Data3	
				W1 = Site + Hole + "_" + Technique + "_CCSF"
				
				If( !Exists( W1 ) ) // This loop checks to see whether the DataWave from the hole containing the interval exists. 
					i += 1				// Sometimes data, like XRF, are only collected over a limited interval and may not have data 
					If( i >= NumPnts( $Splice_Data + ":CCSF_Bottom"  ) ) // for each hole involved in the complete splice. Data from
						Break;															  // missing waves is skipped.	
					EndIf
					Continue
				EndIf
						
				Duplicate/O $W1 Data1, Data2, Data3
				If( StringMatch( Splice_Format, "Splice_Intervals" )  )
					Splice_Top = Splice_Interval_Top( Site, i )
					Splice_Bottom = Splice_Interval_Bottom( Site, i )
				Else
					Splice_Top = Splice_Tie_Top( Site, i )
					Splice_Bottom = Splice_Tie_Bottom( Site, i )
				EndIf
		
//  Data2 is a Mask of 1's and 0's with the 1's identifying the  CCSF and Core that agree with splice section

				WAVE IntervalCoreWave = $Site + Hole + "_" + Technique + "_Core", TieCoreWave = $Site + Hole + "_" + Technique + "_Core" 
	
				If( StringMatch( Splice_Format, "Splice_Intervals" )  )
					Data2 = ( ( Data1 >= Splice_Top ) && ( Data1 < Splice_Bottom ) && ( IntervalCoreWave == Splice_Interval_Core( Site, i ) ) )
				Else
					Data2 = ( ( Data1 >= Splice_Top ) && ( Data1 < Splice_Bottom ) && ( TieCoreWave == Splice_Tie_Core( Site, i ) ) )
				EndIf
				FindLevel/Q Data2,  1  //Finds start of data
				V4 = V_Flag
				V1 = V_LevelX
				If( i == 0 )
					V1 = 0
				EndIf
				FindLevel/Q/R = [V1] Data2,  0  // Finds end of data
				V2 = V_LevelX-1
				V3 = StrLen( Site ) + 8 + StrLen( Technique ) + 1
				
// This is the numeric loop. V4 tells it to skip this section if there are no data from the hole.
		
				If( !V4 )
					j = 0
					Do
						S2 = StringFromList( j, Splice_Waves )
						If( StrLen( S2 ) < 2 )
							Break;
						EndIf
						S3 = S2[ V3, StrLen( S2 ) ]
						If( !StringMatch( S3, "Hole_Index" ) )
							If( !StringMatch( S3, "Age" ) )
							Duplicate/O/R = [ V1, ( V2 ) ]  $Site + Hole + "_" + Technique + "_" + S3  Temp
							EXECUTE "Concatenate {Temp},  " + S2
							EndIf
						EndIf
						j += 1
					While( 1 )
	
//  This is the text loop
			
					j = 0
					Do
						S2 = StringFromList( j, Splice_Waves_TEXT )
						If( StrLen( S2 )<2 )
							Break;
						EndIf
						S3 = S2[V3, StrLen( S2 )]
						Duplicate/O/R = [V1, ( V2 )]  $Site + Hole + "_" + Technique + "_" + S3  TTemp
						EXECUTE "Concatenate {TTemp},  " + S2
						j += 1
					While( 1 )
				EndIf
				i += 1;
			While( i < NumPnts( $Splice_Data + ":CCSF_Bottom"  ) )
			KillWaves/Z Data1, Data2, Data3,  Temp,  TTemp
			Hole_2_Index_F( Site, Technique )
		SetDataFolder root:
	EndMacro

---------------------------------------------------------------

